// This should be pretty easy to follow, I don't do anything too weird. Mostly the code is just copied from the main game. You click, it goes in. You test, it goes out.
// easy, right?

#import "MyView.h"

#define building 0
#define testing 1
#define goldPiece 201
#define waterPiece 202
#define treePiece 203
#define firePiece 204

@implementation MyView

- (id)initWithFrame:(NSRect)frameRect
{
	if ((self = [super initWithFrame:frameRect]) != nil) {
		state = 0;
	}
	return self;
}

- (void)drawRect:(NSRect)rect
{		
	int lcv, lcv2;
	if ( state == 0 ){// get my zillions of tracking rects ready
		for ( lcv = 0; lcv < 20; lcv++ ){
			for ( lcv2 = 0; lcv2 < 10; lcv2++ ){
				boardTrackingRects[lcv][lcv2] = [self addTrackingRect: NSMakeRect((lcv * 40) + 2, (lcv2 * 57) + 2, 36, 53) owner:self userData:[[NSString stringWithFormat :@"%d,%d", lcv,lcv2] retain] assumeInside:NO];
			}
		}
		piecesTrackingRects[0] = [self addTrackingRect: NSMakeRect(800, 513, 40, 57) owner:self userData:@"201" assumeInside:NO];
		piecesTrackingRects[1] = [self addTrackingRect: NSMakeRect(800, 456, 40, 57) owner:self userData:@"202" assumeInside:NO];
		piecesTrackingRects[2] = [self addTrackingRect: NSMakeRect(800, 399, 40, 57) owner:self userData:@"203" assumeInside:NO];
		piecesTrackingRects[3] = [self addTrackingRect: NSMakeRect(800, 342, 40, 57) owner:self userData:@"204" assumeInside:NO];
		state = building;
	}
	[startingBackground compositeToPoint:NSMakePoint( 0, 0 ) fromRect:NSMakeRect( 0, 0, 800, 600 ) operation:NSCompositeSourceOver];
	[gold compositeToPoint:NSMakePoint(800, 513) fromRect:NSMakeRect( 0, 0, 40, 57 ) operation:NSCompositeSourceOver];
	[water compositeToPoint:NSMakePoint(800, 456) fromRect:NSMakeRect( 0, 0, 40, 57 ) operation:NSCompositeSourceOver];
	[tree compositeToPoint:NSMakePoint(800, 399) fromRect:NSMakeRect( 0, 0, 40, 57 ) operation:NSCompositeSourceOver];
	[fire compositeToPoint:NSMakePoint(800, 342) fromRect:NSMakeRect( 0, 0, 40, 57 ) operation:NSCompositeSourceOver];
}

- (id)initWithFrame:(NSRect)frameRect :(controller *)myMaster
{
	
    self = [super initWithFrame:frameRect];
	
	startingBackground = [NSImage imageNamed:@"grid.jpg"];
    hand = [[NSCursor alloc] initWithImage:[[NSImage allocWithZone:[self zone]] initWithContentsOfFile: [[NSBundle bundleForClass:[self class]] pathForResource:@"grabCursor" ofType:@"tiff"]] hotSpot:NSMakePoint(8, 8)]; // init "thing"
	[startingBackground retain];
	
	gold = [NSImage imageNamed:@"gold.tiff"];
	tree = [NSImage imageNamed:@"tree.tiff"];
	water = [NSImage imageNamed:@"water.tiff"];
	fire = [NSImage imageNamed:@"fire.tiff"];
	
	gameFont = [NSMutableDictionary dictionary];
	
	[gameFont setObject:[NSFont boldSystemFontOfSize: 24] forKey:NSFontAttributeName];
	[gameFont setObject:[NSColor blackColor] forKey:NSForegroundColorAttributeName];

    myController = myMaster;
	[NSBezierPath setDefaultLineWidth: 3];
	
	[gameFont retain];
	
    return self;
}

- (void)mouseEntered:(NSEvent *)theEvent
{
	currentRectOver = [[theEvent userData] intValue];
	if ( currentRectOver != goldPiece && currentRectOver != waterPiece && currentRectOver != firePiece && currentRectOver != treePiece ){
		x = [[[[theEvent userData] componentsSeparatedByString:@","] objectAtIndex:0] intValue];
		y = [[[[theEvent userData] componentsSeparatedByString:@","] objectAtIndex:1] intValue];
	}
	
	if ( state == testing ){
		int pickedUp = 1; // I set it to 1, as I've marked myself
		int lcv, lcv2;
		
		currentlyHighlighted = 0;
		
		if ( testboard[x][y] != 0 ){
			for ( lcv = 0; lcv < 20; lcv++ ){
				for ( lcv2 = 0; lcv2 < 10; lcv2++ ){
					boardChecker[lcv][lcv2] = 0; // first we clear it out
				}
			}
			boardChecker[x][y] = 1;
			while ( pickedUp == 1 ){
				pickedUp = 0; //I haven't seen any new ones
				for ( lcv = 0; lcv < 20; lcv++ ){
					for ( lcv2 = 0; lcv2 < 10; lcv2++ ){
						if ( lcv != 19 ){
							if ( boardChecker[lcv][lcv2] == 1 && testboard[lcv + 1][lcv2] == testboard[x][y] && boardChecker[lcv + 1][lcv2] != 1){ // check the right out
								boardChecker[lcv + 1][lcv2] = 1;
								pickedUp = 1;
							}
						} // if
						if ( lcv != 0 ){
							if ( boardChecker[lcv][lcv2] == 1 && testboard[lcv - 1][lcv2] == testboard[x][y] && boardChecker[lcv - 1][lcv2] != 1){ // check the left out
								boardChecker[lcv - 1][lcv2] = 1;
								pickedUp = 1;
							} // if
						}
						if ( lcv2 != 9 ){
							if ( boardChecker[lcv][lcv2] == 1 && testboard[lcv][lcv2 + 1] == testboard[x][y] && boardChecker[lcv][lcv2 + 1] != 1){ // check the above out
								boardChecker[lcv][lcv2 + 1] = 1;
								pickedUp = 1;
							} // if
						}
						if ( lcv2 != 0 ){
							if ( boardChecker[lcv][lcv2] == 1 && testboard[lcv][lcv2 - 1] == testboard[x][y] && boardChecker[lcv][lcv2 - 1] != 1){ // check the below out
								boardChecker[lcv][lcv2 - 1] = 1;
								pickedUp = 1;
							} // if
						}
						
					}// for
				}// for
				
			}// while
		}
		for ( lcv = 0; lcv < 20; lcv++ ){
			for ( lcv2 = 0; lcv2 < 10; lcv2++ ){
				if ( boardChecker[lcv][lcv2] == 1 ){
					currentlyHighlighted++;
				}
			}
		}
		
	}
}
- (void)mouseExited:(NSEvent *)theEvent
{
	
}

- (void)mouseUp:(NSEvent *)theEvent
{
	//	currentRectOver = [[theEvent userData] intValue];
	if ( state == building ){
		if ( currentRectOver == goldPiece || currentRectOver == waterPiece || currentRectOver == treePiece || currentRectOver == firePiece ){
			[self lockFocus];
			[[NSColor colorWithCalibratedRed:0.0 green:1.0 blue:1.0 alpha:.9] set];
			
			[gold compositeToPoint:NSMakePoint(800, 513) fromRect:NSMakeRect( 0, 0, 40, 57 ) operation:NSCompositeSourceOver];
			[water compositeToPoint:NSMakePoint(800, 456) fromRect:NSMakeRect( 0, 0, 40, 57 ) operation:NSCompositeSourceOver];
			[tree compositeToPoint:NSMakePoint(800, 399) fromRect:NSMakeRect( 0, 0, 40, 57 ) operation:NSCompositeSourceOver];
			[fire compositeToPoint:NSMakePoint(800, 342) fromRect:NSMakeRect( 0, 0, 40, 57 ) operation:NSCompositeSourceOver];
			
			if ( currentRectOver == goldPiece )
				[NSBezierPath strokeRect:NSMakeRect(802, 515, 38, 53)];
			if ( currentRectOver == waterPiece )
				[NSBezierPath strokeRect:NSMakeRect(802, 458, 38, 53)];
			if ( currentRectOver == treePiece )
				[NSBezierPath strokeRect:NSMakeRect(802, 401, 38, 53)];
			if ( currentRectOver == firePiece )
				[NSBezierPath strokeRect:NSMakeRect(802, 344, 38, 53)];
			[self unlockFocus];
			[[self window] flushWindow];
			currentlyPlacing = currentRectOver;
		} 
		else {
			if ( board[x][y] == currentlyPlacing )
				board[x][y] = 0;
			else
				board[x][y] = currentlyPlacing;
			[self redrawBoard];
		}
	}
	if (state == testing){
		if ( currentRectOver == goldPiece || currentRectOver == waterPiece || currentRectOver == treePiece || currentRectOver == firePiece ){
			state = building;
			[[NSCursor arrowCursor] set];
			[self redrawBoard];
			return;
		}
		
		int lcv, lcv2;
		
		if (currentlyHighlighted >= 2 ){
			clicksMade++;
			for ( lcv = 0; lcv < 20; lcv++ ){
				for ( lcv2 = 0; lcv2 < 10; lcv2++ ){
					[self removeTrackingRect: boardTrackingRects[lcv][lcv2]]; 
				}
			}
			
			for ( lcv = 0; lcv < 20; lcv++ ){
				for ( lcv2 = 0; lcv2 < 10; lcv2++ ){
					if ( boardChecker[lcv][lcv2] == 1 ){
						testboard[lcv][lcv2] = 0;
						boardChecker[lcv][lcv2] = 0;
					}
				}
			}
			
			/* for every row, starting at the bottom, look at piece X. x starts at 0. If it is blank, bring down the first piece you find.  the next block becomes piece X. 
				in this way, pieces get brought to the bottom, one at a time */
			
			for ( lcv = 0; lcv < 20; lcv++ ){
				for ( lcv2 = 0; lcv2 < 10; lcv2++ ){
					if ( testboard[lcv][lcv2] == 0 ){
						int lcv3;
						for ( lcv3 = lcv2 + 1; lcv3 < 10; lcv3++ ){
							if ( testboard[lcv][lcv3] != 0 ){
								testboard[lcv][lcv2] = testboard[lcv][lcv3];
								testboard[lcv][lcv3] = 0;
								break;
							}
						}
					}	
				}
			}
			
			/* for every col, starting at the left, look at piece X. x starts at 0. If it's blank, bring over all the right colums.  the next block becomes piece X. 
				in this way, pieces get brought to the left, one col at a time */
			
			for ( lcv = 0; lcv < 10; lcv++ ){
				for ( lcv2 = 0; lcv2 < 20; lcv2++ ){
					if ( testboard[lcv2][0] == 0 && testboard[lcv2 + 1][0] != 0){ // as I want x to the right, but 0 up, and I don't want to bother moving blank spaces around
						testboard[lcv2][0] = testboard[lcv2 + 1][0];
						testboard[lcv2 + 1][0] = 0;
						testboard[lcv2][1] = testboard[lcv2 + 1][1];
						testboard[lcv2 + 1][1] = 0;
						testboard[lcv2][2] = testboard[lcv2 + 1][2];
						testboard[lcv2 + 1][2] = 0;
						testboard[lcv2][3] = testboard[lcv2 + 1][3];
						testboard[lcv2 + 1][3] = 0;
						testboard[lcv2][4] = testboard[lcv2 + 1][4];
						testboard[lcv2 + 1][4] = 0;
						testboard[lcv2][5] = testboard[lcv2 + 1][5];
						testboard[lcv2 + 1][5] = 0;
						testboard[lcv2][6] = testboard[lcv2 + 1][6];
						testboard[lcv2 + 1][6] = 0;
						testboard[lcv2][7] = testboard[lcv2 + 1][7];
						testboard[lcv2 + 1][7] = 0;
						testboard[lcv2][8] = testboard[lcv2 + 1][8];
						testboard[lcv2 + 1][8] = 0;
						testboard[lcv2][9] = testboard[lcv2 + 1][9];
						testboard[lcv2 + 1][9] = 0;
					}	
				}
			}								
			
			// now that they are all moved over, let's rebuild the tracking rects for the things that are there
			for ( lcv = 0; lcv < 20; lcv++ ){
				for ( lcv2 = 0; lcv2 < 10; lcv2++ ){
					if ( testboard[lcv][lcv2] != 0 ){
						if (x == lcv && y == lcv2 ){
							boardTrackingRects[lcv][lcv2] = [self addTrackingRect: NSMakeRect((lcv * 40) + 2, (lcv2 * 57) + 2, 36, 53) owner:self userData:[[NSString stringWithFormat :@"%d,%d", lcv,lcv2] retain] assumeInside:YES];
							//tried to use this to let the thing recalculate after they fall so you don't have to jerk the mouse back and forth, but to no avail... it doesn't work. 
						}
						else {
							boardTrackingRects[lcv][lcv2] = [self addTrackingRect: NSMakeRect((lcv * 40) + 2, (lcv2 * 57) + 2, 36, 53) owner:self userData:[[NSString stringWithFormat :@"%d,%d", lcv,lcv2] retain] assumeInside:NO];
						}
					}
				}
			}
		}
		[self redrawBoard];
		currentlyHighlighted = 0;
		for ( lcv = 0; lcv < 20; lcv++ )
			for ( lcv2 = 0; lcv2 < 10; lcv2++ )
				boardChecker[lcv][lcv2] = 0;
					
	}
}

- (void)redrawBoard
{
	if ( state == building ){
	int lcv, lcv2;
	[self lockFocus];
	[startingBackground compositeToPoint:NSMakePoint( 0, 0 ) fromRect:NSMakeRect( 0, 0, 800, 600 ) operation:NSCompositeSourceOver];
	for ( lcv = 0; lcv < 20; lcv++ ){
		for ( lcv2 = 0; lcv2 < 10; lcv2++ ){
			if ( board[lcv][lcv2] == goldPiece )
				[gold compositeToPoint:NSMakePoint(lcv * 40, lcv2 * 57) fromRect:NSMakeRect(0, 0, 40, 57) operation:NSCompositeSourceOver];
			if ( board[lcv][lcv2] == treePiece )
				[tree compositeToPoint:NSMakePoint(lcv * 40, lcv2 * 57) fromRect:NSMakeRect(0, 0, 40, 57) operation:NSCompositeSourceOver];
			if ( board[lcv][lcv2] == waterPiece )
				[water compositeToPoint:NSMakePoint(lcv * 40, lcv2 * 57) fromRect:NSMakeRect(0, 0, 40, 57) operation:NSCompositeSourceOver];
			if ( board[lcv][lcv2] == firePiece )
				[fire compositeToPoint:NSMakePoint(lcv * 40, lcv2 * 57) fromRect:NSMakeRect(0, 0, 40, 57) operation:NSCompositeSourceOver];
		}
	}
	[self unlockFocus];
	[[self window] flushWindow];
	}
	if ( state == testing ){
		int lcv, lcv2;
		[self lockFocus];
		[startingBackground compositeToPoint:NSMakePoint( 0, 0 ) fromRect:NSMakeRect( 0, 0, 800, 600 ) operation:NSCompositeSourceOver];
		for ( lcv = 0; lcv < 20; lcv++ ){
			for ( lcv2 = 0; lcv2 < 10; lcv2++ ){
				if ( testboard[lcv][lcv2] == goldPiece )
					[gold compositeToPoint:NSMakePoint(lcv * 40, lcv2 * 57) fromRect:NSMakeRect(0, 0, 40, 57) operation:NSCompositeSourceOver];
				if ( testboard[lcv][lcv2] == treePiece )
					[tree compositeToPoint:NSMakePoint(lcv * 40, lcv2 * 57) fromRect:NSMakeRect(0, 0, 40, 57) operation:NSCompositeSourceOver];
				if ( testboard[lcv][lcv2] == waterPiece )
					[water compositeToPoint:NSMakePoint(lcv * 40, lcv2 * 57) fromRect:NSMakeRect(0, 0, 40, 57) operation:NSCompositeSourceOver];
				if ( testboard[lcv][lcv2] == firePiece )
					[fire compositeToPoint:NSMakePoint(lcv * 40, lcv2 * 57) fromRect:NSMakeRect(0, 0, 40, 57) operation:NSCompositeSourceOver];
			}
		}
		[[NSString stringWithFormat: @"%d", clicksMade] drawAtPoint:NSMakePoint(600, 570) withAttributes:gameFont];

		[self unlockFocus];
		[[self window] flushWindow];
	}		
}

- (void)mouseDown:(NSEvent *)theEvent
{
	
}

-(void)runTest
{
	int lcv, lcv2;
	state = building;
	[self redrawBoard];
	for ( lcv = 0; lcv < 20; lcv++ ){
		for ( lcv2 = 0; lcv2 < 10; lcv2++ ){
			testboard[lcv][lcv2] = board[lcv][lcv2];
		}
	}
	state = testing;
	clicksMade = 0;
	[hand set];
}

-(void)sendItIn :(NSString *)name :(NSString *)clicks
{	
	int lcv, lcv2;
	NSMutableString *toSend  = [NSMutableString stringWithCapacity :5];
	[toSend appendString: clicks];
	[toSend appendString :@"\n"];
	[toSend appendString: name];
	[toSend appendString :@"\n"];

	// error checking...
		// is the number of clicks an int?
		// are there any blocks not on the ground?
		// Are there spaces between the blocks?
	
	for ( lcv = 0; lcv < 20; lcv++ ){
		for ( lcv2 = 0; lcv2 < 10; lcv2++ ){
			if ( board[lcv][lcv2] == 0 ){
				int lcv3;
				for ( lcv3 = lcv2 + 1; lcv3 < 10; lcv3++ ){
					if ( board[lcv][lcv3] != 0 ){
						NSBeginAlertSheet(@"Sorry", nil, nil, nil, [self window], nil, nil, nil, nil,
										  @"It seems you have at least one piece that is not as low as it can go. Sorry, pieces can't float.");
						return;
					}
				}
			}	
		}
	}
	
	for ( lcv2 = 0; lcv2 < 19; lcv2++ ){
		if ( board[lcv2][0] == 0 && board[lcv2 + 1][0] != 0){ // as I want x to the right, but 0 up, and I don't want to bother moving blank spaces around
			NSLog (@"%d, %d", lcv2, lcv2+1);
			NSBeginAlertSheet(@"Sorry", nil, nil, nil, [self window], nil, nil, nil, nil,
							  @"It seems you have at least one blank column. Sorry, all columns must be together.");
			return;				
		}
	}

	for ( lcv = 0; lcv < 20; lcv++ ){
		for ( lcv2 = 0; lcv2 < 10; lcv2++ ){
			if ( board[lcv][lcv2] != 0 )
				[toSend appendString :[NSString stringWithFormat: @"%d", board[lcv][lcv2] - 200]];
			else 
				[toSend appendString :@"0"];
			board[lcv][lcv2] = 0;
		}
	}
	if (![NSMailDelivery hasDeliveryClassBeenConfigured]) {
		NSBeginAlertSheet(@"Warning", nil, nil, nil, [self window], nil, nil, nil, nil,
						  @"I'm afraid I found your mail not to be as I expected. Perhaps you don't use Apple mail? I've saved what I would have sent to the desktop, can you just email it to me manually? -rziefel@rochester.rr.com- Sorry about that.");
		[toSend writeToFile:[@"~/Desktop/tosend.txt" stringByExpandingTildeInPath] atomically:YES];
	}
	else {	
		if ( [NSMailDelivery deliverMessage: toSend subject: @"puzzle" to: @"rziefel@rochester.rr.com"] ){ // my CS teachers would frown on a method that did something and returned a value like this
			NSBeginAlertSheet(@"Thank you", nil, nil, nil, [self window], nil, nil, nil, nil,
						  @"Thank you for submitting a puzzle. I should mail you soon that I recieved it and when it'll go in.");
		}
			else {
				NSBeginAlertSheet(@"Warning", nil, nil, nil, [self window], nil, nil, nil, nil,
								  @"I'm afraid something happened when I tried to mail. I've saved what I would have sent to the desktop, can you just email it to me manually? -rziefel@rochester.rr.com- Sorry about that.");
				[toSend writeToFile:[@"~/Desktop/tosend.txt" stringByExpandingTildeInPath] atomically:YES];
				
			}
	}
	[self redrawBoard];
}

@end
