@class WebDownload;

@interface MyView : NSView
{
    
	unsigned char keysDown;
	
	NSSound *boinkSound;
	NSSound *chooseSound;
	NSSound *tinkSound;
	NSSound *yip;
	NSSound *letsgo;
	NSSound *crash;
	NSSound *dissolve;
	NSSound *blork;
	NSSound *bell;
	NSSound *click;
	NSSound *slide;
	
	NSImage *startingBackground, *mainBackground, *loseBackground, *winBackground, *challengeBackground, *winChallengeBackground, *looseChallenge;
	NSImage *piecesLayer;
	NSImage *upButton;
	NSImage *downButton;
	NSImage *placeForDate;
	NSImage *acceptPlayerButton;
	NSImage *playButton;
	NSImage *gold, *tree, *water, *fire;
		
	int state;
	int currentFrame, currentFrameDirection, welcomeFrame;
	int currentRectOver;
	int currentPlayerShownStart;
	int currentDateShownStart;
	int playerBoxTrackingRects[5],boardTrackingRects[20][10], datesTrackingRect[8], navigationTrackingRect[2];
	char board[20][10], boardChecker[20][10];
	int normalGameTrackingRect, challengeGameTrackingRect, goButtonTrackingRect, newGameTrakingRect, restartBoardTrackingRect;
	int gameOverPause;
	int currentlyHighlighted, squaresLeft;
	int score;
	int whereClickedX, whereClickedY;
	int offset;
	int boardToChallenge, clicksLeft;
	int percent;
	int animatingFromAWin;
	
	NSMutableArray *challengeList;
	NSMutableArray *trackingRects;
	NSMutableArray *playersArray;
	NSMutableArray *playersNamesArray; // there will always be [count] == 5 as this keeps track of each player. It's made by splitting the file up on the "." character
	NSMutableArray *currentChallengeBoards;
	
	NSTextField *nameField;
	
	NSMutableString *playerName;
	NSMutableString *playerFile;
	
	NSMutableDictionary *gameFont;
	NSMutableDictionary *specialFont;
	
	NSTimer *theTimer;
	
	WebDownload *download;
}
- (id)initWithFrame:(NSRect)frameRect;
- (void)drawRect:(NSRect)rect;

- (void)mouseEntered:(NSEvent *)theEvent;
- (void)mouseExited:(NSEvent *)theEvent;
- (void)mouseUp:(NSEvent *)theEvent;
- (void)mouseDown:(NSEvent *)theEvent;
- (void)drawNameSpace;
- (void)redrawDateSpace;
- (void)redrawNameSpace;
- (void)startTheMainGame;
- (void)doUpdate;
- (void)updateUserListWithDates;
- (void)remakeBoard;

- (void)setupTheChallengeGame;
- (void)startTheChallengeGame;

- (void)timerFired:(id)timer;
- (void)setTimer:(double)interval;
- (void)stopTimer;


- (void)dealloc;

@end
