// If you compile, you'll get like 20+ warnings. That's because I am smarter then the compiler in this case. I KNOW I've given a certain value to the userData and so
// I can ask for it, and get it. But the compiler doesn't see it that way. So the thing works great, just ignore those warnings

// The way I manipulate the userlist is via offsets. That is, if I want the name I ask for the file separated by newlines and ask for the second thing.
// There is probably a better way of doing it, possibly involving XML, but it seemed like a good idea at the time. Oh well.

#import "MyView.h"

#define BIN 2

#define starting 1
#define namingNames 5
#define playingMainGame 2
#define playingChallenge 3
#define mainGameoverLoose 4
#define settingUpChallengeGame 6
#define challengeGameOver 7
#define mainGameoverWin 8
#define showingChallengeInfo 9
#define challengeGameoverLoose 10
#define challengeGameoverWin 11
#define challengeGameTR 60
#define mainGameTR 70
#define addNameButton 8
#define newGameButton 999
#define restartGameButton 998
#define goldPiece 1
#define waterPiece 2
#define treePiece 3
#define firePiece 4
#define upButtonNumber 21
#define downButtonNumber 20

#import <WebKit/WebKit.h>

@implementation MyView

// my precious little C code... yes, we likes it we do... the precious... 
inline int	randBetween( float x, float y )
{
    float	s;
	
    s = (float)(random() % 123456789) / 123456789.0;
    s *= fabs( x - y );
    s += (x > y) ? y : x;
	
    return s;
}

- (id)initWithFrame:(NSRect)frameRect
{
	NSFileManager *manager = [NSFileManager defaultManager];
	
    self = [super initWithFrame:frameRect];
	
	srandom(time(nil));
	
	gameFont = [NSMutableDictionary dictionary];	
	specialFont = [NSMutableDictionary dictionary];	
	nameField = [[NSTextField alloc] initWithFrame: NSMakeRect(490, 55, 100, 25)];

	currentPlayerShownStart = -1; // use this in mouseDown to choose which player to play as
	currentDateShownStart = -1;
	playerBoxTrackingRects[0] = 99;
	playerBoxTrackingRects[1] = 99;
	playerBoxTrackingRects[2] = 99;
	playerBoxTrackingRects[3] = 99;
	playerBoxTrackingRects[4] = 99;
	
	state = 0;
	currentFrame = 0;
	currentFrameDirection = 1;
	welcomeFrame = 0;
	score = 0;
	percent = 0;
	animatingFromAWin = 0;
	
	[gameFont setObject:[NSFont boldSystemFontOfSize: 24] forKey:NSFontAttributeName];
	[gameFont setObject:[NSColor whiteColor] forKey:NSForegroundColorAttributeName];
	[specialFont setObject:[NSFont boldSystemFontOfSize: 24] forKey:NSFontAttributeName];
	[specialFont setObject:[NSColor yellowColor] forKey:NSForegroundColorAttributeName];

	// here I will have to read the preferences and create NSImages for each player I find.
	// set up the rects to click on, 
	
	// I really should do some error checking here, to make sure I don't get nil for anything here
	boinkSound = [[NSSound alloc] initWithContentsOfFile: [[NSBundle bundleForClass:[self class]] pathForResource:@"boink" ofType:@"mp3"] byReference: YES];
	chooseSound = [[NSSound alloc] initWithContentsOfFile: [[NSBundle bundleForClass:[self class]] pathForResource:@"boink" ofType:@"mp3"] byReference: YES];
	yip = [[NSSound alloc] initWithContentsOfFile: [[NSBundle bundleForClass:[self class]] pathForResource:@"yip" ofType:@"mp3"] byReference: YES];
	tinkSound = [[NSSound alloc] initWithContentsOfFile: [[NSBundle bundleForClass:[self class]] pathForResource:@"tink" ofType:@"aif"] byReference: YES];
	letsgo = [[NSSound alloc] initWithContentsOfFile: [[NSBundle bundleForClass:[self class]] pathForResource:@"letsgo" ofType:@"wav"] byReference: YES];
	crash = [[NSSound alloc] initWithContentsOfFile: [[NSBundle bundleForClass:[self class]] pathForResource:@"crashing" ofType:@"wav"] byReference: YES];
	dissolve = [[NSSound alloc] initWithContentsOfFile: [[NSBundle bundleForClass:[self class]] pathForResource:@"dissolve" ofType:@"aif"] byReference: YES];
	blork = [[NSSound alloc] initWithContentsOfFile: [[NSBundle bundleForClass:[self class]] pathForResource:@"blork" ofType:@"mp3"] byReference: YES];
	bell = [[NSSound alloc] initWithContentsOfFile: [[NSBundle bundleForClass:[self class]] pathForResource:@"bell" ofType:@"mp4"] byReference: YES];
	click = [[NSSound alloc] initWithContentsOfFile: [[NSBundle bundleForClass:[self class]] pathForResource:@"click" ofType:@"wav"] byReference: YES];
	slide  = [[NSSound alloc] initWithContentsOfFile: [[NSBundle bundleForClass:[self class]] pathForResource:@"slide" ofType:@"mp3"] byReference: YES];
	
	startingBackground = [NSImage imageNamed:@"startingbackground.jpg"];
	loseBackground = [NSImage imageNamed:@"youloose.jpg"];
	winBackground = [NSImage imageNamed:@"youwin.jpg"];
	winChallengeBackground = [NSImage imageNamed:@"wonChallenge.jpg"];
	looseChallenge =  [NSImage imageNamed:@"youlosechallenge.jpg"];
	piecesLayer = [NSImage imageNamed:@"blank.tiff"];
	upButton = [NSImage imageNamed:@"up.tiff"];
	downButton = [NSImage imageNamed:@"down.tiff"];
	acceptPlayerButton = [NSImage imageNamed:@"gobutton.tiff"];
	playButton = [NSImage imageNamed:@"playbutton.jpg"];
	gold = [NSImage imageNamed:@"gold.tiff"];
	tree = [NSImage imageNamed:@"tree.tiff"];
	water = [NSImage imageNamed:@"water.tiff"];
	fire = [NSImage imageNamed:@"fire.tiff"];
	placeForDate = [NSImage imageNamed:@"placeForDate.tiff"];
	

	trackingRects = [NSMutableArray arrayWithCapacity :1];
	playerName = [NSMutableString stringWithCapacity :10];
	
	if (!([manager fileExistsAtPath:@"/Users/Shared/Same Game Challenge/UserList" isDirectory:nil]) ){
		// let's make one!
		playerFile = [NSMutableString stringWithCapacity :10];
		[manager createDirectoryAtPath:@"/Users/Shared/Same Game Challenge" attributes:nil];
		[manager createDirectoryAtPath:@"/Users/Shared/Same Game Challenge/Levels" attributes:nil];
		[playerFile setString:@"New Player\n\n4-14-06 0 0%\n.\nNew Player\n\n4-14-06 0 0%\n.\nNew Player\n\n4-14-06 0 0%\n.\nNew Player\n\n4-14-06 0 0%\n.\nNew Player\n\n4-14-06 0 0%\n"];
		[playerFile writeToFile:@"/Users/Shared/Same Game Challenge/UserList" atomically:YES];
		[@"3\nRobert Ziefel\n44444400004300000000441100000041110000004300000000444444000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\n.\n7\nRobert Ziefel\n11132000002000000000111000000020000000001110000000320000000011100000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\n.\n7\nRobert Ziefel\n44444420001111114000444443400043114340004342434000434443400041111340002444442000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\n.\n7\nRobert Ziefel\n44233441342114123112000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\n.\n7\nRobert Ziefel\n11231200002312122100000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\n.\n9\nRobert Ziefel\n13213000001332400000122330000021231000002123200000124320000012112000004331300000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\n.\n11\nRobert Ziefel\n12121200003333400000114300000031300000003232400000412121200000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\n.\n9\nRobert Ziefel\n41420000002421200000131240000021313000002000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\n.\n13\nRobert Ziefel\n41000000003400000000324000000032140000001311400000312334000012312400001444400000420000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\n.\n12\nRobert Ziefel\n12100000003141000000343100000041130000003123000000143400000012310000002210000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\n.\n12\nRobert Ziefel\n43311300003313130000321132000022321300003112330000322231000031323100002211220000121231000043233100000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000\n.\n14\nRobert Ziefel\n14430000001343000000142200000013240000001243000000122300000013430000001234000000123200000013420000001434000000123400000022410000000000000000000000000000000000000000000000000000000000000000000000000000\n.\n15\nRobert Ziefel\n44000000001400000000130000000021000000001300000000420000000022000000003100000000310000000024000000004200000000220000000014000000004300000000110000000023000000003300000000420000000021000000001100000000\n.\n" writeToFile:@"/Users/Shared/Same Game Challenge/Levels/4-14-06" atomically:YES];
		[@"4-14-06" writeToFile:@"/Users/Shared/Same Game Challenge/dates" atomically:YES];
	} else
		playerFile = [NSMutableString stringWithContentsOfFile: @"/Users/Shared/Same Game Challenge/UserList"];

	playersNamesArray = [NSMutableArray arrayWithArray :[playerFile componentsSeparatedByString:@".\n"]];
	
	currentChallengeBoards= [NSMutableArray arrayWithCapacity :1];
	[currentChallengeBoards retain];
	challengeList = [NSMutableArray arrayWithCapacity :1];
	[challengeList retain];
	
	[NSBezierPath setDefaultLineWidth: 3];
	[piecesLayer retain];
	[gameFont retain];
	[trackingRects retain];
	[nameField retain];
	[playersArray retain];
	[acceptPlayerButton retain];
	[playersNamesArray retain];
	[playerName retain];
	[playerFile retain];
	[specialFont retain];
	[fire retain];
	[water retain];
	[gold retain];
	[tree retain];
	[tinkSound retain];
	[placeForDate retain];
	[yip retain];
	[letsgo retain];
	[crash retain];
	[dissolve retain];
	[blork retain];
	[bell retain];
	[click retain];
	[slide retain];
    return self;
}

- (void)drawRect:(NSRect)rect
{
	int lcv, lcv2;
	//********************************** these little things just help separate the different if statments, as there's a bunch of them
	if ( state == 0 ){
		challengeGameTrackingRect = [self addTrackingRect: NSMakeRect(67, 68, 182, 67) owner:self userData:@"60" assumeInside:NO];
		normalGameTrackingRect = [self addTrackingRect: NSMakeRect(554, 68, 182, 67) owner:self userData:@"70" assumeInside:NO];

		[[NSColor blackColor] set];
		[startingBackground compositeToPoint:NSMakePoint(0, 0) fromRect:NSMakeRect(0, 0, 800, 600) operation:NSCompositeSourceOver];

		[self drawNameSpace];
			
		state = starting;
		[[NSColor whiteColor] set];
		return;
	}
	//**********************************
	if ( state == starting ){
		//This is a leftover from virus attack. Not sure if I ever want to animate the opening screen, but if I did, this would be how
		if ( currentFrame == 59 ){
			currentFrameDirection *= -1;
			currentFrame = 0; // We've done one loop of animation. Whew
		}
		welcomeFrame += currentFrameDirection;
		[self redrawNameSpace];
		return;
	}
	//**********************************
	if ( state == playingMainGame || state == playingChallenge ){
		currentlyHighlighted = 0;
		[[NSColor colorWithCalibratedRed:1.0 green:1.0 blue:0.0 alpha:.8] set];
		[piecesLayer compositeToPoint:NSMakePoint(0, 0) fromRect:NSMakeRect(0, 0, 800, 580) operation:NSCompositeSourceOver];
		for ( lcv = 0; lcv < 20; lcv++ ){
			for ( lcv2 = 0; lcv2 < 10; lcv2++ ){
				if ( boardChecker[lcv][lcv2] == 1 ){
					[NSBezierPath fillRect:NSMakeRect(lcv * 40, lcv2 * 57, 40, 57)];
					currentlyHighlighted++;
				}
			}
		}
			//********************************** I'm not redrawing the whole screen much, but when I do, I need to put the top part back. These next couple do that
		if ( state == playingMainGame ){
			[[NSColor whiteColor] set];
			[NSBezierPath fillRect:NSMakeRect(0, 570, 800, 40)];
			[[NSString stringWithFormat: @"Score: %d", score] drawAtPoint:NSMakePoint(600, 570) withAttributes:gameFont];
			[@"New Game" drawAtPoint:NSMakePoint(100, 570) withAttributes:gameFont];
			return;
		} 
			//**********************************
		if ( state == playingChallenge ){
			[[NSColor whiteColor] set];
			[NSBezierPath fillRect:NSMakeRect(0, 570, 800, 40)];
			[gameFont setObject:[NSColor blackColor] forKey:NSForegroundColorAttributeName];
			[[NSString stringWithFormat: @"Clicks: %d", clicksLeft] drawAtPoint:NSMakePoint(600, 570) withAttributes:gameFont];
			[@"Restart" drawAtPoint:NSMakePoint(100, 570) withAttributes:gameFont];		
			[@"Quit" drawAtPoint:NSMakePoint(300, 570) withAttributes:gameFont];
			return;
		}
	}
		//**********************************
	if ( state == mainGameoverLoose){
		[crash play];
		[loseBackground compositeToPoint:NSMakePoint(0, 0) fromRect:NSMakeRect(0, 0, 800, 580) operation:NSCompositeSourceOver];
		[[NSColor whiteColor] set];
		[NSBezierPath fillRect:NSMakeRect(0, 570, 800, 40)];
		[[NSString stringWithFormat: @"Score: %d", score] drawAtPoint:NSMakePoint(600, 570) withAttributes:gameFont];
		[@"New Game" drawAtPoint:NSMakePoint(100, 570) withAttributes:gameFont];
		return;
	}
		//**********************************
	if ( state == challengeGameoverLoose){
		[looseChallenge compositeToPoint:NSMakePoint(0, 0) fromRect:NSMakeRect(0, 0, 800, 580) operation:NSCompositeSourceOver];
		[[NSColor whiteColor] set];
		[NSBezierPath fillRect:NSMakeRect(0, 570, 800, 40)];
		[@"Restart" drawAtPoint:NSMakePoint(100, 570) withAttributes:gameFont];		
		[@"Quit" drawAtPoint:NSMakePoint(300, 570) withAttributes:gameFont];
		return;
	}
		//**********************************
	if ( state == mainGameoverWin){
		[winBackground compositeToPoint:NSMakePoint(0, 0) fromRect:NSMakeRect(0, 0, 800, 580) operation:NSCompositeSourceOver];
		[[NSColor whiteColor] set];
		[NSBezierPath fillRect:NSMakeRect(0, 570, 800, 40)];
		[[NSString stringWithFormat: @"Score: %d", score] drawAtPoint:NSMakePoint(600, 570) withAttributes:gameFont];
		[@"New Game" drawAtPoint:NSMakePoint(100, 570) withAttributes:gameFont];
		return;
	}
	if ( state == challengeGameoverWin ){
		[winChallengeBackground compositeToPoint:NSMakePoint(0, 0) fromRect:NSMakeRect(0, 0, 800, 580) operation:NSCompositeSourceOver];
		return;		
	}
		//**********************************
	if ( state == showingChallengeInfo ){
			// I want 60 tics of fading to black
			// wait 15 tics
			// 120 tics of showing the name
			// show the board
		if ( currentFrame == 0 )
			[dissolve play];
		if ( currentFrame >= 0 && currentFrame <= 60 ){
			[[NSColor colorWithCalibratedRed:0.0 green:0.0 blue:0.0 alpha:.02 * currentFrame] set];

			if ( animatingFromAWin == 1 ){
				[winChallengeBackground compositeToPoint:NSMakePoint(0, 0) fromRect:NSMakeRect(0, 0, 800, 580) operation:NSCompositeSourceOver];
			}
			else
			{
				[challengeBackground compositeToPoint:NSMakePoint(0, 0) fromRect:NSMakeRect(0, 0, 800, 600) operation:NSCompositeSourceOver];
				[downButton compositeToPoint:NSMakePoint(350, 250) fromRect:NSMakeRect(0, 0, 128, 37) operation:NSCompositeSourceOver];
				[upButton compositeToPoint:NSMakePoint(350, 562) fromRect:NSMakeRect(0, 0, 128, 37) operation:NSCompositeSourceOver]; // there's room for 8 37 pixel high squares between them, with 2 pixels for space
			}
			[NSBezierPath fillRect:NSMakeRect(0, 0, 800, 600)];
		}
		if ( currentFrame >= 61 && currentFrame < 180 ){
			[[NSString stringWithFormat: @"%@\n   Clicks: %@",[[[currentChallengeBoards objectAtIndex: boardToChallenge] componentsSeparatedByString:@"\n"] objectAtIndex:1],
							[[[currentChallengeBoards objectAtIndex: boardToChallenge] componentsSeparatedByString:@"\n"] objectAtIndex:0]] drawAtPoint:NSMakePoint(320, 280) withAttributes:gameFont];
			
		}
		if (currentFrame == 180 )
			[dissolve play];
		if ( currentFrame >= 180 && currentFrame <= 279 ){
			[[NSColor colorWithCalibratedRed:0.0 green:0.0 blue:0.0 alpha:abs(279 - currentFrame) * .01] set];
			[piecesLayer compositeToPoint:NSMakePoint(0, 0) fromRect:NSMakeRect(0, 0, 800, 580) operation:NSCompositeSourceOver];
			
			[NSBezierPath fillRect:NSMakeRect(0, 0, 800, 600)];
		}
		
		if ( currentFrame >= 280 ){
			[self stopTimer];
			state = playingChallenge;
			[piecesLayer compositeToPoint:NSMakePoint(0, 0) fromRect:NSMakeRect(0, 0, 800, 580) operation:NSCompositeSourceOver];
			[gameFont setObject:[NSColor blackColor] forKey:NSForegroundColorAttributeName];
		}
	}
	currentFrame++;
}

- (void)mouseEntered:(NSEvent *)theEvent
{
	int tempSize;
	currentRectOver = [[theEvent userData] intValue];	
//**********************************
	if ( state == starting) {
		if ( currentRectOver >= 0 && currentRectOver <= 5 ){ // it's one of the names. Challenge is 60 and start game is 70
			tempSize = [[[[playersNamesArray objectAtIndex: currentRectOver] componentsSeparatedByString:@"\n"] objectAtIndex:0] sizeWithAttributes :gameFont].width;
			[self lockFocus];
			[[[[playersNamesArray objectAtIndex: currentRectOver] componentsSeparatedByString:@"\n"] objectAtIndex:0] drawAtPoint:NSMakePoint(350, 250 + (currentRectOver * 75)) withAttributes:specialFont];
			[[[[playersNamesArray objectAtIndex: currentRectOver] componentsSeparatedByString:@"\n"] objectAtIndex:1] drawAtPoint:NSMakePoint(tempSize + 360, 250 + (currentRectOver * 75)) withAttributes:gameFont];
			[self unlockFocus];
			[[self window] flushWindow];
			[boinkSound play];
			return;
		}
		if ( currentRectOver == challengeGameTR  ){
			[self lockFocus];
			[[NSColor colorWithCalibratedRed:0.0 green:1.0 blue:1.0 alpha:.9] set];
			[NSBezierPath strokeRect:NSMakeRect(56, 67, 182, 67)];
			[self unlockFocus];
			[[self window] flushWindow];
			[yip play];
			return;
		}
		if ( currentRectOver == mainGameTR  ){
			[self lockFocus];
			[[NSColor colorWithCalibratedRed:0.0 green:1.0 blue:1.0 alpha:.9] set];
			[NSBezierPath strokeRect:NSMakeRect(554, 68, 182, 67)];
			[self unlockFocus];
			[[self window] flushWindow];
			[letsgo play];
			return;
		}
	}
	//**********************************
	if ( state == settingUpChallengeGame ){
		if ( currentRectOver == mainGameTR ){ // in other words, the play challange button - I just reused these, naughty boy
			[self lockFocus];
			[[NSColor colorWithCalibratedRed:0.0 green:1.0 blue:1.0 alpha:.9] set];
			[NSBezierPath strokeRect:NSMakeRect(554, 68, 182, 67)];
			[self unlockFocus];
			[[self window] flushWindow];
			return;
		}
		if ( currentRectOver == challengeGameTR ){ // the update button
			[self lockFocus];
			[[NSColor colorWithCalibratedRed:0.0 green:1.0 blue:1.0 alpha:.9] set];
			[NSBezierPath strokeRect:NSMakeRect(56, 67, 182, 67)];
			[self unlockFocus];
			[[self window] flushWindow];
			return;
		}
		if ( currentRectOver >= 0 && currentRectOver <= 7 ){ // it's one of the dates
			[self redrawDateSpace];
			[self lockFocus];
			[[[[[[playersNamesArray objectAtIndex: currentPlayerShownStart] componentsSeparatedByString:@"\n"] objectAtIndex:2 + offset + currentRectOver] componentsSeparatedByString:@" "] objectAtIndex:2] drawAtPoint:NSMakePoint(500, 291 + (currentRectOver * 39)) withAttributes:gameFont];
			[[[[NSMutableString stringWithContentsOfFile: @"/Users/Shared/Same Game Challenge/dates"] componentsSeparatedByString:@"\n"] objectAtIndex:currentRectOver + offset] drawAtPoint:NSMakePoint(360, 291 + (39 * currentRectOver)) withAttributes:specialFont];
			[self unlockFocus];
			[[self window] flushWindow];
			return;
		}		
		if ( currentRectOver == upButtonNumber ){
			[blork play];
			[self lockFocus];
			[[NSColor colorWithCalibratedRed:0.0 green:1.0 blue:1.0 alpha:.9] set];
			[NSBezierPath strokeRect:NSMakeRect(350, 562, 128, 37)];
			[self unlockFocus];
			[[self window] flushWindow];
			return;
		}
		if ( currentRectOver == downButtonNumber ){
			[blork play];
			[self lockFocus];
			[[NSColor colorWithCalibratedRed:0.0 green:1.0 blue:1.0 alpha:.9] set];
			[NSBezierPath strokeRect:NSMakeRect(350, 250, 128, 37)];
			[self unlockFocus];
			[[self window] flushWindow];
			return;
		}
	}
	//**********************************
	if ( state == challengeGameoverWin ){
		if ( [[theEvent userData] isEqualToString:@"998"] ){
			currentlyHighlighted = 0;
			currentRectOver = restartGameButton;
			[self lockFocus];
			[[NSColor colorWithCalibratedRed:0.0 green:1.0 blue:1.0 alpha:.9] set];
			[NSBezierPath strokeRect:NSMakeRect(597, 53, 180, 66)];
			[self unlockFocus];
			[[self window] flushWindow];
			return;
		} 			
		if ( [[theEvent userData] isEqualToString:@"999"] ){
			currentlyHighlighted = 0;
			currentRectOver = newGameButton;
			[self lockFocus];
			[[NSColor colorWithCalibratedRed:0.0 green:1.0 blue:1.0 alpha:.9] set];
			[NSBezierPath strokeRect:NSMakeRect(45, 53, 180, 66)];
			[self unlockFocus];
			[[self window] flushWindow];
			return;
		} 
	}
	//**********************************
	if ( state == mainGameoverLoose || state == playingMainGame || state == mainGameoverWin ){
		if ( [[theEvent userData] isEqualToString:@"999"] ){
			currentlyHighlighted = 0;
			currentRectOver = 999;
			[self lockFocus];
			[[NSColor colorWithCalibratedRed:0.0 green:1.0 blue:1.0 alpha:.9] set];
			[NSBezierPath strokeRect:NSMakeRect(100, 572, 130, 28)];
			[self unlockFocus];
			[[self window] flushWindow];
			return;
		}
	}
	//**********************************
	if ( state == playingChallenge || state == challengeGameoverLoose){ // I must do this one separatly, as "new game" is longer then "restart"
		if ( [[theEvent userData] isEqualToString:@"999"] ){
			currentlyHighlighted = 0;
			currentRectOver = 999;
			[self lockFocus];
			[[NSColor colorWithCalibratedRed:0.0 green:1.0 blue:1.0 alpha:.9] set];
			[NSBezierPath strokeRect:NSMakeRect(100, 572, 90, 28)];
			[self unlockFocus];
			[[self window] flushWindow];
			return;
		}
		if ( [[theEvent userData] isEqualToString:@"998"] ){
			currentlyHighlighted = 0;
			currentRectOver = 998;
			[self lockFocus];
			[[NSColor colorWithCalibratedRed:0.0 green:1.0 blue:1.0 alpha:.9] set];
			[NSBezierPath strokeRect:NSMakeRect(300, 572, 60, 28)];
			[self unlockFocus];
			[[self window] flushWindow];
			return;
		}
		
	}
	//********************************** Finally, some meat. This figures out where the highlights should go, if there are like things next to what you mouse over
	if ( state == playingMainGame || state == playingChallenge){
		int pickedUp = 1; // I set it to 1, as I've marked myself
		int currentX, currentY;
		int lcv, lcv2;
		currentX = [[[[theEvent userData] componentsSeparatedByString:@","] objectAtIndex:0] intValue];
		currentY = [[[[theEvent userData] componentsSeparatedByString:@","] objectAtIndex:1] intValue];
		
		whereClickedX = currentX;
		whereClickedY = currentY;
			
		if ( board[currentX][currentY] != 0 ){
			for ( lcv = 0; lcv < 20; lcv++ ){
				for ( lcv2 = 0; lcv2 < 10; lcv2++ ){
					boardChecker[lcv][lcv2] = 0; // first we clear it out
				}
			}
			// it's actually pretty easy. It just checks every single square against what it wants. If a like color is next to it, it's marked and checked the next time
			// then, when everything has been checked or marked as checked, we're done and we know what to highlight. 
			// my CS teachers probably would have wanted me to use something stupid like recusion here, but I am not that stupid
			boardChecker[currentX][currentY] = 1;
			while ( pickedUp == 1 ){
				pickedUp = 0; //I haven't seen any new ones
				for ( lcv = 0; lcv < 20; lcv++ ){
					for ( lcv2 = 0; lcv2 < 10; lcv2++ ){
						if ( lcv != 19 ){ // don't go off the edge of the array, yo!
							if ( boardChecker[lcv][lcv2] == 1 && board[lcv + 1][lcv2] == board[currentX][currentY] && boardChecker[lcv + 1][lcv2] != 1){ // check the right out
								boardChecker[lcv + 1][lcv2] = 1;
								pickedUp = 1;
							}
						} // if
						if ( lcv != 0 ){
							if ( boardChecker[lcv][lcv2] == 1 && board[lcv - 1][lcv2] == board[currentX][currentY] && boardChecker[lcv - 1][lcv2] != 1){ // check the left out
								boardChecker[lcv - 1][lcv2] = 1;
								pickedUp = 1;
							} // if
						}
						if ( lcv2 != 9 ){
							if ( boardChecker[lcv][lcv2] == 1 && board[lcv][lcv2 + 1] == board[currentX][currentY] && boardChecker[lcv][lcv2 + 1] != 1){ // check the above out
								boardChecker[lcv][lcv2 + 1] = 1;
								pickedUp = 1;
							} // if
						}
						if ( lcv2 != 0 ){
							if ( boardChecker[lcv][lcv2] == 1 && board[lcv][lcv2 - 1] == board[currentX][currentY] && boardChecker[lcv][lcv2 - 1] != 1){ // check the below out
								boardChecker[lcv][lcv2 - 1] = 1;
								pickedUp = 1;
							} // if
						}
						
					}// for
				}// for
				
			}// while
			[self setNeedsDisplay: YES];
		}
	}// main ifs
}

- (void)mouseExited:(NSEvent *)theEvent
{ // basically, just put back the background over what you just highlighted
	currentRectOver = [[theEvent userData] intValue];
	//**********************************
	if ( state == starting) {
		if ( currentRectOver >= 0 && currentRectOver <= 5 ){ // it's one of the names. Challenge is 6 and start game is 7
			[self redrawNameSpace];
			currentRectOver = -1;
		}
		if ( currentRectOver == challengeGameTR  ){
			[self lockFocus];
			[startingBackground compositeToPoint:NSMakePoint(54, 64) fromRect:NSMakeRect(54, 64, 187, 73) operation:NSCompositeSourceOver];
			[self unlockFocus];
			[[self window] flushWindow];
			currentRectOver = -1;
		}
		if ( currentRectOver == mainGameTR  ){
			[self lockFocus];
			[startingBackground compositeToPoint:NSMakePoint(552, 64) fromRect:NSMakeRect(552, 64, 187, 73) operation:NSCompositeSourceOver];
			[self unlockFocus];
			[[self window] flushWindow];
			currentRectOver = -1;
		}			
	}
	//**********************************
	if ( state == settingUpChallengeGame ){
		if ( currentRectOver ==  mainGameTR ){
			[self lockFocus];
			[challengeBackground compositeToPoint:NSMakePoint(552, 64) fromRect:NSMakeRect(552, 64, 187, 73) operation:NSCompositeSourceOver];
			[self unlockFocus];
			[[self window] flushWindow];
			currentRectOver = -1;
			return;
		}
		if ( currentRectOver == challengeGameTR  ){
			[self lockFocus];			
			[challengeBackground compositeToPoint:NSMakePoint(54, 64) fromRect:NSMakeRect(54, 64, 187, 73) operation:NSCompositeSourceOver];
			[self unlockFocus];
			[[self window] flushWindow];
			currentRectOver = -1;
			return;
		}			
		if ( currentRectOver >= 0 && currentRectOver <= 7 ){ // it's one of the names. Challenge is 60 and start game is 70
			[self lockFocus];
			[[[[NSMutableString stringWithContentsOfFile: @"/Users/Shared/Same Game Challenge/dates"] componentsSeparatedByString:@"\n"] objectAtIndex:currentRectOver + offset] drawAtPoint:NSMakePoint(360, 291 + (39 * currentRectOver)) withAttributes:gameFont];
			[self unlockFocus];
			[[self window] flushWindow];
			currentRectOver = -1;
			return;
		}				
		if ( currentRectOver == downButtonNumber ){
			[self lockFocus];
			[challengeBackground compositeToPoint:NSMakePoint(348, 248) fromRect:NSMakeRect(348, 248, 132, 41) operation:NSCompositeSourceOver];
			[downButton compositeToPoint:NSMakePoint(350, 250) fromRect:NSMakeRect(0, 0, 128, 37) operation:NSCompositeSourceOver];
			[self unlockFocus];
			[[self window] flushWindow];
			currentRectOver = -1;
			return;
		}
		if ( currentRectOver == upButtonNumber ){
			[self lockFocus];
			[challengeBackground compositeToPoint:NSMakePoint(348, 560) fromRect:NSMakeRect(348, 560, 132, 41) operation:NSCompositeSourceOver];
			[upButton compositeToPoint:NSMakePoint(350, 562) fromRect:NSMakeRect(0, 0, 128, 37) operation:NSCompositeSourceOver];
			[self unlockFocus];
			[[self window] flushWindow];
			currentRectOver = -1;
			return;
		}		
	}	
	//**********************************
	if ( state == playingMainGame || state == mainGameoverLoose || state == mainGameoverWin){
		if ( [[theEvent userData] isEqualToString:@"999"] ){
			[self lockFocus];
			[[NSColor whiteColor] set];
			[NSBezierPath fillRect:NSMakeRect(0, 570, 800, 40)];
			[[NSString stringWithFormat: @"Score: %d", score] drawAtPoint:NSMakePoint(600, 570) withAttributes:gameFont];
			[@"New Game" drawAtPoint:NSMakePoint(100, 570) withAttributes:gameFont];
			[self unlockFocus];
			[[self window] flushWindow];
			currentRectOver = -1;
			return;
		}
	}
	//**********************************
	if ( state == playingChallenge || state == challengeGameoverLoose ){
		[self lockFocus];
		[[NSColor whiteColor] set];
		[NSBezierPath fillRect:NSMakeRect(0, 570, 800, 40)];
		[[NSString stringWithFormat: @"Clicks: %d", clicksLeft] drawAtPoint:NSMakePoint(600, 570) withAttributes:gameFont];
		[@"Restart" drawAtPoint:NSMakePoint(100, 570) withAttributes:gameFont];
		[@"Quit" drawAtPoint:NSMakePoint(300, 570) withAttributes:gameFont];
		[self unlockFocus];
		currentRectOver = -1;
		[[self window] flushWindow];
		return;
	}
	//*******************************
	if ( state == challengeGameoverWin ){
		if ( [[theEvent userData] isEqualToString:@"998"] ){
			currentRectOver = -1;
			[self lockFocus];
			[winChallengeBackground compositeToPoint:NSMakePoint(596, 51) fromRect:NSMakeRect(596, 51, 184, 71) operation:NSCompositeSourceOver];
			[self unlockFocus];
			[[self window] flushWindow];			
		}
		if ( [[theEvent userData] isEqualToString:@"999"] ){
			currentRectOver = -1;
			[self lockFocus];
			[winChallengeBackground compositeToPoint:NSMakePoint(43, 51) fromRect:NSMakeRect(43, 51, 184, 71) operation:NSCompositeSourceOver];
			[self unlockFocus];
			[[self window] flushWindow];			
		}
	}
}

- (void)mouseDown:(NSEvent *)theEvent
{
	if ( state == starting) {
		if ( currentRectOver == challengeGameTR  ){
			[self lockFocus];
			[playButton compositeToPoint:NSMakePoint(54, 65) fromRect:NSMakeRect(0, 0, 187, 73) operation:NSCompositeSourceOver];
			[self unlockFocus];
			[[self window] flushWindow];
		}
		if ( currentRectOver == mainGameTR  ){
			[self lockFocus];
			[playButton compositeToPoint:NSMakePoint(552, 66) fromRect:NSMakeRect(0, 0, 187, 73) operation:NSCompositeSourceOver];
			[self unlockFocus];
			[[self window] flushWindow];
		}
	}
}

- (void)mouseUp:(NSEvent *)theEvent
{
	int tempSize;
	//********************************************
	if ( state == starting) {
		if ( currentRectOver >= 0 && currentRectOver <= 5 ){ // it's one of the names. Challenge is 6 and start game is 7
			currentPlayerShownStart = currentRectOver;
			if ( [[[[playersNamesArray objectAtIndex: currentRectOver] componentsSeparatedByString:@"\n"] objectAtIndex:0] isEqualToString:@"New Player"]) {
				[chooseSound play];
				state = namingNames;
				[nameField setObjectValue :@""];
				tempSize = [[[[playersNamesArray objectAtIndex: currentRectOver] componentsSeparatedByString:@"\n"] objectAtIndex:0] sizeWithAttributes :gameFont].width;
				[nameField setFrame: NSMakeRect(360 + tempSize, 250 + (currentRectOver * 75), 100, 25)];
				[self addSubview: nameField];
				[self lockFocus];
				[acceptPlayerButton compositeToPoint:NSMakePoint(600, 250 + (currentRectOver * 75)) fromRect:NSMakeRect(0, 0, 47, 32) operation:NSCompositeSourceOver];
				goButtonTrackingRect = [self addTrackingRect: NSMakeRect(600, 250 + (currentRectOver * 75), 47, 32) owner:self userData:@"8" assumeInside:NO];

				[self unlockFocus];
				[[self window] flushWindow];	
				//[self redrawNameSpace];
				return;
			}
			[self redrawNameSpace];
			return;

		}		
		if ( currentRectOver == challengeGameTR  ){
			if ( currentPlayerShownStart == -1 ){
				NSBeep();
				[self lockFocus];
				[@"Please choose a name" drawAtPoint:NSMakePoint(34, 135) withAttributes:gameFont];
				[self unlockFocus];
				[[self window] flushWindow];
				return;
			} else {
				state = settingUpChallengeGame;
				[self setupTheChallengeGame];
				return;
			}
		}
		if ( currentRectOver == mainGameTR ){
			if ( currentPlayerShownStart == -1 ){
				NSBeep();
				[self lockFocus];
				[@"Please choose a name" drawAtPoint:NSMakePoint(502, 139) withAttributes:gameFont];
				[self unlockFocus];
				[[self window] flushWindow];
				return;
			} else {
				state = playingMainGame;
				[self startTheMainGame];
				return;
			}
		}
	}
	//********************************************
	if ( state == settingUpChallengeGame ){
		if ( currentRectOver == challengeGameTR ){ // in other words, the update button
			[bell play];
			[self doUpdate];
			return;
		}
		if ( currentRectOver >= 0 && currentRectOver <= 7 ){ // it's one of the dates
			[click play];
			currentDateShownStart = currentRectOver;
			[self redrawDateSpace];
			return;
		}
		if ( currentRectOver == mainGameTR ){ // in other words, the start playing button
			if ( currentDateShownStart == -1 ){
				NSBeep();
				[self lockFocus];
				[@"Please choose a date" drawAtPoint:NSMakePoint(502, 139) withAttributes:gameFont];
				[self unlockFocus];
				[[self window] flushWindow];
				return;
			} else {
				currentFrame = 0;
				animatingFromAWin = 0;
				[self removeTrackingRect:challengeGameTrackingRect];
				[self removeTrackingRect:normalGameTrackingRect];
				state = showingChallengeInfo;
				[self startTheChallengeGame];
				[gameFont setObject:[NSColor whiteColor] forKey:NSForegroundColorAttributeName];
				[self setTimer:.03]; // this makes it go 30 frames a second no matter how powerful your hardware
				return;
			}
		}

		if ( currentRectOver == downButtonNumber ){
			offset--;
			[self redrawDateSpace];
			return;
		}
		if ( currentRectOver == upButtonNumber ){
			offset++;
			[self redrawDateSpace];
			return;
		}				
	}
	//********************************************
	if ( state == namingNames ){
		if ( currentRectOver == addNameButton ){
			// note that this tempSize is keeping a different "size", the length of the string, not how many pixels it is onscreen
			int tempSize = [[[[playersNamesArray objectAtIndex: currentPlayerShownStart] componentsSeparatedByString:@"\n"] objectAtIndex:0] length];
			// to get at the later things I just add them up. Like if I want to change the high score, I'll get object 0 + 1
			[playersNamesArray replaceObjectAtIndex:currentPlayerShownStart withObject:[NSString stringWithFormat:@"%@%@",[nameField objectValue], [[playersNamesArray objectAtIndex:currentPlayerShownStart] substringFromIndex:tempSize]]];
			[[NSString stringWithFormat:@"%@.\n%@.\n%@.\n%@.\n%@", [playersNamesArray objectAtIndex: 0], [playersNamesArray objectAtIndex: 1],[playersNamesArray objectAtIndex: 2],[playersNamesArray objectAtIndex: 3],[playersNamesArray objectAtIndex: 4]] writeToFile:@"/Users/Shared/Same Game Challenge/UserList" atomically:YES];
			state = starting;
			if ([nameField superview])
				[nameField removeFromSuperview];
			[self removeTrackingRect: goButtonTrackingRect];
			[self redrawNameSpace];
			return;
		}
	}
	//********************************************
	if ( state == mainGameoverLoose || state == playingMainGame || state == mainGameoverWin){
		if ( currentRectOver == newGameButton ){
			int lcv, lcv2;
			for ( lcv = 0; lcv < 20; lcv++ ){
				for ( lcv2 = 0; lcv2 < 10; lcv2++ ){
					[self removeTrackingRect: boardTrackingRects[lcv][lcv2]]; 
				}
			}
				
			[self startTheMainGame];
			return;
		}
	}
	//********************************************
	if ( state == challengeGameoverWin ){
		if ( currentRectOver == restartGameButton ){
			if ( percent != 100 ){
				currentFrame = 0;
				state = showingChallengeInfo;
				animatingFromAWin = 1;
				[self startTheChallengeGame];
				[gameFont setObject:[NSColor whiteColor] forKey:NSForegroundColorAttributeName];
				[self setTimer:.03]; // this makes it go 30 frames a second no matter how powerful your hardware
				[self removeTrackingRect:challengeGameTrackingRect];
				[self removeTrackingRect:normalGameTrackingRect];
				return;
			}
			else {
				[self lockFocus];
				[@"100% complete!" drawAtPoint:NSMakePoint(593, 121) withAttributes:specialFont];
				[self unlockFocus];
				[[self window] flushWindow];
				return;
			}
		}
		if ( currentRectOver == newGameButton ){
			[self removeTrackingRect:normalGameTrackingRect];
			[self removeTrackingRect:challengeGameTrackingRect];
			[self setupTheChallengeGame];
			state = settingUpChallengeGame;
			return;
		}
	}
	//********************************************
	if ( state == playingChallenge || state == challengeGameoverLoose){
		if ( currentRectOver == newGameButton ){
			state = playingChallenge;
			[self startTheChallengeGame];
			[self setNeedsDisplay:YES];
			return;
		}
		if ( currentRectOver == restartGameButton ){
			int lcv, lcv2;
			for ( lcv = 0; lcv < 20; lcv++ ){
				for ( lcv2 = 0; lcv2 < 10; lcv2++ ){
					[self removeTrackingRect: boardTrackingRects[lcv][lcv2]]; 
				}
			}
			[self setupTheChallengeGame];
			state = settingUpChallengeGame;
			return;
		}
		// if we got here, we must be mousing up over some freaking squares, finally. 
		// I already know if I can take any away, from finding the highlight. So, if I can, do so and redraw the board. Otherwise, do nothing
		[self lockFocus];
		[[NSColor whiteColor] set];
		[NSBezierPath fillRect:NSMakeRect(0, 570, 800, 40)];
		[[NSString stringWithFormat: @"Clicks: %d", clicksLeft] drawAtPoint:NSMakePoint(600, 570) withAttributes:gameFont];
		[@"Restart" drawAtPoint:NSMakePoint(100, 570) withAttributes:gameFont];
		[@"Quit" drawAtPoint:NSMakePoint(300, 570) withAttributes:gameFont];
		[self unlockFocus];
		
		if (currentlyHighlighted >= 2 ){
			[tinkSound play];
			squaresLeft = squaresLeft - currentlyHighlighted;
			clicksLeft--;
			
			[self remakeBoard];
			
			// now we see if we can continue playing
			if ( clicksLeft == 0 && squaresLeft != 0 )
				state = challengeGameoverLoose;
			if ( clicksLeft == 0 && squaresLeft == 0 ){
				// well yee-ha! You did it
				int lcv;
				percent = 0;
				// get the string up to the point of the current board
				// recreate the next line using numberOfBoardsDone and remaking the %
				// add that information back in
				// write the file out
				
				NSMutableString *buildingString = [NSMutableString stringWithCapacity :5];

				[buildingString appendString: [[[playersNamesArray objectAtIndex: currentPlayerShownStart] componentsSeparatedByString:@"\n"] objectAtIndex:0]]; // the name
				[buildingString appendString: @"\n"];
				[buildingString appendString: [[[playersNamesArray objectAtIndex: currentPlayerShownStart] componentsSeparatedByString:@"\n"] objectAtIndex:1]]; // the current high score
				
				for ( lcv = 2; lcv < offset + currentDateShownStart + 2; lcv++ ){
					[buildingString appendString: @"\n"];
					[buildingString appendString: [[[playersNamesArray objectAtIndex: currentPlayerShownStart] componentsSeparatedByString:@"\n"] objectAtIndex: lcv]]; // the boards until the current board
				}	
				boardToChallenge++;
				percent = (boardToChallenge/([currentChallengeBoards count] - 1.0)) * 100; // the - 1 is because there is a .\n at the end of the last one, as there could be only one
									// using 1.0 here, which seems meaningless, but without it, 1/2 = 0. No, really. 
				[buildingString appendString: [NSString stringWithFormat: @"\n%@ %d %d%%", [[[[[playersNamesArray objectAtIndex: currentPlayerShownStart] componentsSeparatedByString:@"\n"] objectAtIndex:lcv] componentsSeparatedByString:@" "] objectAtIndex:0],
					boardToChallenge, percent]];
				
				for ( lcv = offset + currentDateShownStart + 3; lcv < [[[playersNamesArray objectAtIndex: currentPlayerShownStart] componentsSeparatedByString:@"\n"] count]; lcv++ ){
					[buildingString appendString: @"\n"];
					[buildingString appendString: [[[playersNamesArray objectAtIndex: currentPlayerShownStart] componentsSeparatedByString:@"\n"] objectAtIndex:lcv]]; // the boards after the current board
				}				
				
				[playersNamesArray replaceObjectAtIndex:currentPlayerShownStart withObject:buildingString];
				
				[[NSString stringWithFormat:@"%@.\n%@.\n%@.\n%@.\n%@", [playersNamesArray objectAtIndex: 0], [playersNamesArray objectAtIndex: 1],[playersNamesArray objectAtIndex: 2],[playersNamesArray objectAtIndex: 3],[playersNamesArray objectAtIndex: 4]] writeToFile:@"/Users/Shared/Same Game Challenge/UserList" atomically:YES];
				
				[self removeTrackingRect: newGameTrakingRect];
				[self removeTrackingRect: restartBoardTrackingRect];
				restartBoardTrackingRect = [self addTrackingRect: NSMakeRect(596, 50, 185, 70) owner:self userData:@"998" assumeInside:NO];
				newGameTrakingRect = [self addTrackingRect: NSMakeRect(45, 50, 185, 70) owner:self userData:@"999" assumeInside:NO];
				state = challengeGameoverWin;

			}
		}
		[self setNeedsDisplay: YES];
		return;
	}
	//********************************************
	if ( state == playingMainGame ){
		int lcv, lcv2;
		int continuePlaying = 1;
		
		if (currentlyHighlighted >= 2 ){
			[tinkSound play];
			squaresLeft = squaresLeft - currentlyHighlighted;

			[self remakeBoard];
		
			// now see if we can cantinue playing.
			continuePlaying = 0; // we assume we're not going to continue
			for ( lcv = 0; lcv < 20; lcv++ ){
				for ( lcv2 = 0; lcv2 < 10; lcv2++ ){
					if ( ( board[lcv][lcv2] == board[lcv + 1][lcv2] || 
						 board[lcv][lcv2] == board[lcv - 1][lcv2] || 
						 board[lcv][lcv2] == board[lcv][lcv2 + 1] || 
						   board[lcv][lcv2] == board[lcv][lcv2 - 1] ) && board[lcv][lcv2] != 0){
						continuePlaying = 1;
						continue; // why keep looking if we already know we're going to continue?
					}
				}
			}
			if (squaresLeft == 0 ){ // as if there are no squares, there are no matches left, so we want to check for that first
				int tempSize = [[[[playersNamesArray objectAtIndex: currentPlayerShownStart] componentsSeparatedByString:@"\n"] objectAtIndex:0] length] + 
				[[[[playersNamesArray objectAtIndex: currentPlayerShownStart] componentsSeparatedByString:@"\n"] objectAtIndex:1] length];

				state = mainGameoverWin;
				score += 500;
				if ( score > [[[[playersNamesArray objectAtIndex: currentPlayerShownStart] componentsSeparatedByString:@"\n"] objectAtIndex:1] intValue] ){
					[playersNamesArray replaceObjectAtIndex:currentPlayerShownStart withObject:[NSString stringWithFormat:@"%@\n%d%@",[[[playersNamesArray objectAtIndex: currentPlayerShownStart] componentsSeparatedByString:@"\n"] objectAtIndex:0],
						score, [[playersNamesArray objectAtIndex:currentPlayerShownStart] substringFromIndex:tempSize + 1]]];
					[[NSString stringWithFormat:@"%@.\n%@.\n%@.\n%@.\n%@", [playersNamesArray objectAtIndex: 0], [playersNamesArray objectAtIndex: 1],[playersNamesArray objectAtIndex: 2],[playersNamesArray objectAtIndex: 3],[playersNamesArray objectAtIndex: 4]] writeToFile:@"/Users/Shared/Same Game Challenge/UserList" atomically:YES];
				}
				[self setNeedsDisplay: YES];
				return;
			}
			if ( continuePlaying == 0 ){
				int tempSize = [[[[playersNamesArray objectAtIndex: currentPlayerShownStart] componentsSeparatedByString:@"\n"] objectAtIndex:0] length] + 
				[[[[playersNamesArray objectAtIndex: currentPlayerShownStart] componentsSeparatedByString:@"\n"] objectAtIndex:1] length];
				state = mainGameoverLoose;
	// to get at the later things I just add them up. Like if I want to change the high score, I'll get object 0 + 1
				if ( score > [[[[playersNamesArray objectAtIndex: currentPlayerShownStart] componentsSeparatedByString:@"\n"] objectAtIndex:1] intValue] ){
					[playersNamesArray replaceObjectAtIndex:currentPlayerShownStart withObject:[NSString stringWithFormat:@"%@\n%d%@",[[[playersNamesArray objectAtIndex: currentPlayerShownStart] componentsSeparatedByString:@"\n"] objectAtIndex:0],
						score, [[playersNamesArray objectAtIndex:currentPlayerShownStart] substringFromIndex:tempSize + 1]]];
					[[NSString stringWithFormat:@"%@.\n%@.\n%@.\n%@.\n%@", [playersNamesArray objectAtIndex: 0], [playersNamesArray objectAtIndex: 1],[playersNamesArray objectAtIndex: 2],[playersNamesArray objectAtIndex: 3],[playersNamesArray objectAtIndex: 4]] writeToFile:@"/Users/Shared/Same Game Challenge/UserList" atomically:YES];
				}
				[self setNeedsDisplay: YES];
			}
		}
	}
}

- (void)remakeBoard
{
	int lcv, lcv2;
	
	for ( lcv = 0; lcv < 20; lcv++ ){
		for ( lcv2 = 0; lcv2 < 10; lcv2++ ){
			[self removeTrackingRect: boardTrackingRects[lcv][lcv2]]; // I figured it would be easier to just tear it all down and build it all back up
																	  // at once, rather then do a little bit here and a little bit there, based on all the moving around that's possible to do
		}
	}
		
	score += (currentlyHighlighted * currentlyHighlighted) - (3 * currentlyHighlighted) + 4;
	currentlyHighlighted = 0;
	// this takes them out of the board
	for ( lcv = 0; lcv < 20; lcv++ ){
		for ( lcv2 = 0; lcv2 < 10; lcv2++ ){
			if ( boardChecker[lcv][lcv2] == 1 ){
				board[lcv][lcv2] = 0;
				boardChecker[lcv][lcv2] = 0;
			}
		}
	}
		
	/* for every row, starting at the bottom, look at piece X. x starts at 0. If it is blank, bring down the first piece you find.  the next block becomes piece X. 
		in this way, pieces get brought to the bottom, one at a time */
	
	for ( lcv = 0; lcv < 20; lcv++ ){
		for ( lcv2 = 0; lcv2 < 10; lcv2++ ){
			if ( board[lcv][lcv2] == 0 ){
				int lcv3;
				for ( lcv3 = lcv2 + 1; lcv3 < 10; lcv3++ ){
					if ( board[lcv][lcv3] != 0 ){
						board[lcv][lcv2] = board[lcv][lcv3];
						board[lcv][lcv3] = 0;
						break;
					}
				}
			}	
		}
	}
		
	/* for every col, starting at the left, look at piece X. x starts at 0. If it's blank, bring over all the right colums.  the next block becomes piece X. 
		in this way, pieces get brought to the left, one col at a time */
	
	for ( lcv = 0; lcv < 10; lcv++ ){
		for ( lcv2 = 0; lcv2 < 20; lcv2++ ){
			if ( board[lcv2][0] == 0 && board[lcv2 + 1][0] != 0){ // as I want x to the right, but 0 up, and I don't want to bother moving blank spaces around
				board[lcv2][0] = board[lcv2 + 1][0];
				board[lcv2 + 1][0] = 0;
				board[lcv2][1] = board[lcv2 + 1][1];
				board[lcv2 + 1][1] = 0;
				board[lcv2][2] = board[lcv2 + 1][2];
				board[lcv2 + 1][2] = 0;
				board[lcv2][3] = board[lcv2 + 1][3];
				board[lcv2 + 1][3] = 0;
				board[lcv2][4] = board[lcv2 + 1][4];
				board[lcv2 + 1][4] = 0;
				board[lcv2][5] = board[lcv2 + 1][5];
				board[lcv2 + 1][5] = 0;
				board[lcv2][6] = board[lcv2 + 1][6];
				board[lcv2 + 1][6] = 0;
				board[lcv2][7] = board[lcv2 + 1][7];
				board[lcv2 + 1][7] = 0;
				board[lcv2][8] = board[lcv2 + 1][8];
				board[lcv2 + 1][8] = 0;
				board[lcv2][9] = board[lcv2 + 1][9];
				board[lcv2 + 1][9] = 0;
			}	
		}
	}								
		
	// now that they are all moved over, let's rebuild the tracking rects for the things that are there
	for ( lcv = 0; lcv < 20; lcv++ ){
		for ( lcv2 = 0; lcv2 < 10; lcv2++ ){
			if ( board[lcv][lcv2] != 0 ){
				if (whereClickedX == lcv && whereClickedY == lcv2 ){
					boardTrackingRects[lcv][lcv2] = [self addTrackingRect: NSMakeRect((lcv * 40) + 2, (lcv2 * 57) + 2, 36, 53) owner:self userData:[[NSString stringWithFormat :@"%d,%d", lcv,lcv2] retain] assumeInside:YES];
					//tried to use this to let the thing recalculate after they fall so you don't have to jerk the mouse back and forth, but to no avail... it doesn't work. 
				}
				else {
					boardTrackingRects[lcv][lcv2] = [self addTrackingRect: NSMakeRect((lcv * 40) + 2, (lcv2 * 57) + 2, 36, 53) owner:self userData:[[NSString stringWithFormat :@"%d,%d", lcv,lcv2] retain] assumeInside:NO];
				}
			}
		}
	}
	// and then remake the pieces layer
	[piecesLayer lockFocus];
	for ( lcv = 0; lcv < 20; lcv++ ){
		for ( lcv2 = 0; lcv2 < 10; lcv2++ ){
			if ( board[lcv][lcv2] == goldPiece )
				[gold compositeToPoint:NSMakePoint(lcv * 40, lcv2 * 57) fromRect:NSMakeRect(0, 0, 40, 57) operation:NSCompositeSourceOver];
			else if ( board[lcv][lcv2] == treePiece )
				[tree compositeToPoint:NSMakePoint(lcv * 40, lcv2 * 57) fromRect:NSMakeRect(0, 0, 40, 57) operation:NSCompositeSourceOver];
			else if ( board[lcv][lcv2] == waterPiece )
				[water compositeToPoint:NSMakePoint(lcv * 40, lcv2 * 57) fromRect:NSMakeRect(0, 0, 40, 57) operation:NSCompositeSourceOver];
			else if ( board[lcv][lcv2] == firePiece )
				[fire compositeToPoint:NSMakePoint(lcv * 40, lcv2 * 57) fromRect:NSMakeRect(0, 0, 40, 57) operation:NSCompositeSourceOver];
			else // I didn't want to do it this way, I wanted to have two "layers" but I just got blackness when I tried that. Stupid blackness
				[mainBackground compositeToPoint:NSMakePoint(lcv * 40, lcv2 * 57) fromRect:NSMakeRect(lcv * 40, lcv2 * 57, 40, 57) operation:NSCompositeSourceOver];
		}
	}
	[piecesLayer unlockFocus];
	[self setNeedsDisplay: YES];
}
- (void)drawNameSpace
{
	int lcv;
	int tempSize; // it would just be too freaking long of a line without this

	for ( lcv = 0; lcv < 5; lcv++){
		// this line cuts the current line apart by \n to get item 0, the actual name. This is then written to the right place
		[[[[playersNamesArray objectAtIndex: lcv] componentsSeparatedByString:@"\n"] objectAtIndex:0] drawAtPoint:NSMakePoint(350, 250 + (lcv * 75)) withAttributes:gameFont];
		tempSize = [[[[playersNamesArray objectAtIndex: lcv] componentsSeparatedByString:@"\n"] objectAtIndex:0] sizeWithAttributes :gameFont].width;
		playerBoxTrackingRects[lcv] = [self addTrackingRect: NSMakeRect(350, 250 + (lcv * 75), tempSize, 37) owner:self userData:[[NSString stringWithFormat :@"%d", lcv] retain] assumeInside:NO];
	}
}

- (void)redrawDateSpace
{
	int lcv;
	NSArray *listArray = [[NSMutableString stringWithContentsOfFile: @"/Users/Shared/Same Game Challenge/dates"] componentsSeparatedByString:@"\n"];
	
	[self removeTrackingRect:datesTrackingRect[0]];
	[self removeTrackingRect:datesTrackingRect[1]];
	[self removeTrackingRect:datesTrackingRect[2]];
	[self removeTrackingRect:datesTrackingRect[3]];
	[self removeTrackingRect:datesTrackingRect[4]];
	[self removeTrackingRect:datesTrackingRect[5]];
	[self removeTrackingRect:datesTrackingRect[6]];
	[self removeTrackingRect:datesTrackingRect[7]];
	
	if ( [listArray count] > 7 ){
		if ( offset > [listArray count] - 7){ // we've gone too far
			offset--;
			NSBeep();
		}
		else
			[slide play];
		if ( offset < 0 ){ // we've gone too far
			offset = 0;
			NSBeep();
		}
		else 
			[slide play];
	} else 
		offset = 0; // don't bother, we don't have enough to move anyway
	
	[self lockFocus];
	[challengeBackground compositeToPoint:NSMakePoint(325, 237) fromRect:NSMakeRect(325, 237, 400, 338) operation:NSCompositeSourceOver];
	[downButton compositeToPoint:NSMakePoint(350, 250) fromRect:NSMakeRect(0, 0, 128, 37) operation:NSCompositeSourceOver];
	[upButton compositeToPoint:NSMakePoint(350, 562) fromRect:NSMakeRect(0, 0, 128, 37) operation:NSCompositeSourceOver]; // there's room for 8 37 pixel high squares between them, with 2 pixels for space
	
	for (lcv = offset; lcv < ([listArray count] >= (7 + offset) ? (7 + offset) : [listArray count]); lcv++ ){
		if ( lcv < [listArray count] ){
			[placeForDate compositeToPoint:NSMakePoint(350, 289 + (39 * (lcv - offset))) fromRect:NSMakeRect(0, 0, 128, 37) operation:NSCompositeSourceOver]; 
			[[listArray objectAtIndex: lcv] drawAtPoint:NSMakePoint(360, 291 + (39 * (lcv - offset))) withAttributes:gameFont];
			datesTrackingRect[lcv - offset] = [self addTrackingRect: NSMakeRect(348, 289 + (39 * (lcv - offset)), 128, 34) owner:self userData:[[NSString stringWithFormat :@"%d", lcv - offset] retain] assumeInside:NO];
		}
	}
	if ( currentDateShownStart != -1 ){
		[[NSColor colorWithCalibratedRed:0.0 green:1.0 blue:1.0 alpha:.9] set];
		[NSBezierPath strokeRect:NSMakeRect(352, 291 + (currentDateShownStart * 39), 126, 35)];
		
	}
	[self unlockFocus];
	[[self window] flushWindow];	
}

- (void)redrawNameSpace
{
	int lcv;
	int tempSize; // it would just be too freaking long of a line without this - I use it to find how long to make the highlight
	
	[self lockFocus];
	[startingBackground compositeToPoint:NSMakePoint(325, 237) fromRect:NSMakeRect(325, 237, 400, 438) operation:NSCompositeSourceOver];

	for ( lcv = 0; lcv < 5; lcv++){
		[[[[playersNamesArray objectAtIndex: lcv] componentsSeparatedByString:@"\n"] objectAtIndex:0] drawAtPoint:NSMakePoint(350, 250 + (lcv * 75)) withAttributes:gameFont];
	}
	if ( currentPlayerShownStart != -1 ){
		tempSize = [[[[playersNamesArray objectAtIndex: currentPlayerShownStart] componentsSeparatedByString:@"\n"] objectAtIndex:0] sizeWithAttributes :gameFont].width;
		[[NSColor colorWithCalibratedRed:0.0 green:1.0 blue:1.0 alpha:.9] set];
		[NSBezierPath strokeRect:NSMakeRect(350, 248 + (currentPlayerShownStart * 75), tempSize + 2, 37)];

	}
	[self unlockFocus];
	[[self window] flushWindow];

}

- (void)setupTheChallengeGame
{
	NSEnumerator *enumerator_;
	id object;
	int lcv;
	// actually what I should do here is load the files in a loop based on the dates file. Then I can let the user know if one is missing
	NSArray *listArray = [[NSMutableString stringWithContentsOfFile: @"/Users/Shared/Same Game Challenge/dates"] componentsSeparatedByString:@"\n"];
	enumerator_= [[NSFileManager defaultManager] enumeratorAtPath:@"/Users/Shared/Same Game Challenge/Levels"];
	[challengeList removeAllObjects];
	if ( challengeBackground == nil ) // don't load it twice, duh
	challengeBackground= [NSImage imageNamed:@"challengeBackground.jpg"];
	[challengeBackground retain];
	[gameFont setObject:[NSColor whiteColor] forKey:NSForegroundColorAttributeName];
	while ((object = [enumerator_ nextObject])) {
		if ( [object rangeOfString :@"." options:NSCaseInsensitiveSearch | NSLiteralSearch].length == 0 ){
			//bypass that stupid .DS_Store file OS X likes to leave everyplace
			[challengeList addObject :[NSString stringWithContentsOfFile: [NSString stringWithFormat: @"/Users/Shared/Same Game Challenge/Levels/%@", object]]];
		}
	}
	[self lockFocus];
	[challengeBackground compositeToPoint:NSMakePoint(0, 0) fromRect:NSMakeRect(0, 0, 800, 600) operation:NSCompositeSourceOver];
	[downButton compositeToPoint:NSMakePoint(350, 250) fromRect:NSMakeRect(0, 0, 128, 37) operation:NSCompositeSourceOver];
	navigationTrackingRect[0] = [self addTrackingRect: NSMakeRect(350, 250, 128, 37) owner:self userData:@"20" assumeInside:NO];
	[upButton compositeToPoint:NSMakePoint(350, 562) fromRect:NSMakeRect(0, 0, 128, 37) operation:NSCompositeSourceOver]; // there's room for 8 37 pixel high squares between them, with 2 pixels for space
	navigationTrackingRect[1] = [self addTrackingRect: NSMakeRect(350, 562, 128, 37) owner:self userData:@"21" assumeInside:NO];

	offset = 0;
	for (lcv = 0; lcv < ([challengeList count] >= 7 ? 7 : [challengeList count]); lcv++ ){ // slight trickery here, if there are more then 7, use 7 as the limit, otherwise, use however many there are
			[placeForDate compositeToPoint:NSMakePoint(350, 289 + (39 * lcv)) fromRect:NSMakeRect(0, 0, 128, 37) operation:NSCompositeSourceOver]; 
			[[listArray objectAtIndex: lcv] drawAtPoint:NSMakePoint(360, 291 + (39 * lcv)) withAttributes:gameFont];
			datesTrackingRect[lcv] = [self addTrackingRect: NSMakeRect(348, 289 + (39 * lcv), 128, 34) owner:self userData:[[NSString stringWithFormat :@"%d", lcv] retain] assumeInside:NO];

	}
	[self unlockFocus];
	[[self window] flushWindow];
	[self removeTrackingRect:playerBoxTrackingRects[0]];
	[self removeTrackingRect:playerBoxTrackingRects[1]];
	[self removeTrackingRect:playerBoxTrackingRects[2]];
	[self removeTrackingRect:playerBoxTrackingRects[3]];
	[self removeTrackingRect:playerBoxTrackingRects[4]];
	[self removeTrackingRect:challengeGameTrackingRect];
	[self removeTrackingRect:normalGameTrackingRect];
	[self removeTrackingRect: newGameTrakingRect];
	[self removeTrackingRect: restartBoardTrackingRect];
	
	challengeGameTrackingRect = [self addTrackingRect: NSMakeRect(56, 67, 182, 67) owner:self userData:@"60" assumeInside:NO];
	normalGameTrackingRect = [self addTrackingRect: NSMakeRect(554, 68, 182, 67) owner:self userData:@"70" assumeInside:NO];

	state = settingUpChallengeGame;
}

- (void)startTheChallengeGame
{ 
	int lcv, lcv2, popper = 0; // because we're 'popping' the characters off the string, one at a time - this builds the board[][] from a plain old string
	NSArray *listArray = [[NSMutableString stringWithContentsOfFile: @"/Users/Shared/Same Game Challenge/dates"] componentsSeparatedByString:@"\n"];
	[currentChallengeBoards removeAllObjects];
	[currentChallengeBoards addObjectsFromArray :[[NSMutableString stringWithContentsOfFile: [NSString stringWithFormat: @"/Users/Shared/Same Game Challenge/Levels/%@", [listArray objectAtIndex: currentDateShownStart + offset]]] componentsSeparatedByString:@".\n"]];
	boardToChallenge = [[[[[[playersNamesArray objectAtIndex: currentPlayerShownStart] componentsSeparatedByString:@"\n"] objectAtIndex:2 + offset + currentDateShownStart] componentsSeparatedByString:@" "] objectAtIndex:1] intValue];
	
	if ( boardToChallenge >= [currentChallengeBoards count] - 1 ){ // then start over you freak (- 1, don't forget that last one on the end because of the .\n)
		boardToChallenge = 0;
	}
	
	NSString *boardCharacters = [NSString stringWithString :[[[currentChallengeBoards objectAtIndex: boardToChallenge] componentsSeparatedByString:@"\n"] objectAtIndex:2]];
	
	[self removeTrackingRect:datesTrackingRect[0]];
	[self removeTrackingRect:datesTrackingRect[1]];
	[self removeTrackingRect:datesTrackingRect[2]];
	[self removeTrackingRect:datesTrackingRect[3]];
	[self removeTrackingRect:datesTrackingRect[4]];
	[self removeTrackingRect:datesTrackingRect[5]];
	[self removeTrackingRect:datesTrackingRect[6]];
	[self removeTrackingRect:datesTrackingRect[7]];
	[self removeTrackingRect:navigationTrackingRect[0]];
	[self removeTrackingRect:navigationTrackingRect[1]];
	[self removeTrackingRect:normalGameTrackingRect];
	[self removeTrackingRect:challengeGameTrackingRect];

	for ( lcv = 0; lcv < 20; lcv++ ){
		for ( lcv2 = 0; lcv2 < 10; lcv2++ ){
			[self removeTrackingRect: boardTrackingRects[lcv][lcv2]];
		}
	}
		
	squaresLeft = 0;
	for ( lcv = 0; lcv < 20; lcv++ ){
		for ( lcv2 = 0; lcv2 < 10; lcv2++ ){
			if ( [boardCharacters characterAtIndex: popper] == '0' )
				board[lcv][lcv2] = 0;
			if ( [boardCharacters characterAtIndex: popper] == '1' ){
				board[lcv][lcv2] = goldPiece;
				squaresLeft++;
			}
			if ( [boardCharacters characterAtIndex: popper] == '2' ){
				board[lcv][lcv2] = treePiece;
				squaresLeft++;
			}
			if ( [boardCharacters characterAtIndex: popper] == '3' ){
				board[lcv][lcv2] = waterPiece;
				squaresLeft++;
			}
			if ( [boardCharacters characterAtIndex: popper] == '4' ){
				board[lcv][lcv2] = firePiece;
				squaresLeft++;
			}
			popper++;
		}
	}
	// piece 0,1 is to the right 0, and up 1
	[mainBackground release];
	mainBackground = [NSImage imageNamed:[NSString stringWithFormat:@"%d.jpg", (int)randBetween(1,35)]];
	[mainBackground retain];
	[piecesLayer setSize: NSMakeSize(800, 600)];
	[piecesLayer lockFocus];
	for ( lcv = 0; lcv < 20; lcv++ ){
		for ( lcv2 = 0; lcv2 < 10; lcv2++ ){
			if ( board[lcv][lcv2] == goldPiece )
				[gold compositeToPoint:NSMakePoint(lcv * 40, lcv2 * 57) fromRect:NSMakeRect(0, 0, 40, 57) operation:NSCompositeSourceOver];
			else if ( board[lcv][lcv2] == treePiece )
				[tree compositeToPoint:NSMakePoint(lcv * 40, lcv2 * 57) fromRect:NSMakeRect(0, 0, 40, 57) operation:NSCompositeSourceOver];
			else if ( board[lcv][lcv2] == waterPiece )
				[water compositeToPoint:NSMakePoint(lcv * 40, lcv2 * 57) fromRect:NSMakeRect(0, 0, 40, 57) operation:NSCompositeSourceOver];
			else if ( board[lcv][lcv2] == firePiece )
				[fire compositeToPoint:NSMakePoint(lcv * 40, lcv2 * 57) fromRect:NSMakeRect(0, 0, 40, 57) operation:NSCompositeSourceOver];
			else
				[mainBackground compositeToPoint:NSMakePoint(lcv * 40, lcv2 * 57) fromRect:NSMakeRect(lcv * 40, lcv2 * 57, 40, 57) operation:NSCompositeSourceOver];

			if (board[lcv][lcv2] != 0 )
				boardTrackingRects[lcv][lcv2] = [self addTrackingRect: NSMakeRect((lcv * 40) + 2, (lcv2 * 57) + 2, 36, 53) owner:self userData:[[NSString stringWithFormat :@"%d,%d", lcv,lcv2] retain] assumeInside:NO];
		}
	}
	[piecesLayer unlockFocus];
	[gameFont setObject:[NSColor blackColor] forKey:NSForegroundColorAttributeName];
	[self removeTrackingRect: newGameTrakingRect];
	[self removeTrackingRect: restartBoardTrackingRect];
	newGameTrakingRect = [self addTrackingRect: NSMakeRect(100, 570, 130, 50) owner:self userData:@"999" assumeInside:NO];
	restartBoardTrackingRect = [self addTrackingRect: NSMakeRect(300, 570, 50, 50) owner:self userData:@"998" assumeInside:NO];
	clicksLeft = [[[[currentChallengeBoards objectAtIndex: boardToChallenge] componentsSeparatedByString:@"\n"] objectAtIndex:0] intValue];
}

- (void)doUpdate{
	int lcv;
	int didNeedUpdates = 0;
	NSArray *toBeDownloaded;
	NSString *list = [NSString stringWithContentsOfURL :[NSURL URLWithString:@"http://www.smoonstore.com/sgc/dates.txt"]];
	NSMutableString *currentDownload = [NSMutableString stringWithCapacity :10];
	NSFileManager *manager = [NSFileManager defaultManager];
	
	// this method is "depreciated" meaning- "we want to remove support for this call so you have to write your program for 10.x instead of 10.(x-1 | 2)
	// so more people buy 10.x instead of sticking with 10.(x - 1 | 2). But as I want to write for 10.3 and 10.4, I have to use it. I suppose when 10.5 comes
	// olong, I'll have to change it, but for now, it works
	
	[self lockFocus];
	[@"Please Wait... checking server" drawAtPoint:NSMakePoint(34, 135) withAttributes:gameFont];
	[self unlockFocus];
	[[self window] flushWindow];
				
	if ( list == nil ){
		NSBeginAlertSheet(@"Sorry", nil, nil, nil, [self window], nil, nil, nil, nil,
						  @"I could not reach the update server. Perhaps it's down, or you do not have an open internet connection?");
		return;
	}
	[list writeToFile:@"/Users/Shared/Same Game Challenge/dates" atomically:YES];
	toBeDownloaded = [NSArray arrayWithArray :[list componentsSeparatedByString:@"\n"]];
	for ( lcv = 0; lcv < [toBeDownloaded count]; lcv++ ){
		if (!([manager fileExistsAtPath:[NSString stringWithFormat:@"/Users/Shared/Same Game Challenge/Levels/%@", [toBeDownloaded objectAtIndex:lcv]]  isDirectory:nil]) ){
			[currentDownload setString: [NSString stringWithContentsOfURL :[NSURL URLWithString: [NSString stringWithFormat:@"http://www.smoonstore.com/sgc/%@.txt", [toBeDownloaded objectAtIndex:lcv]]]]];
			if ( [currentDownload length] == 0 ){ // this check doesn't actually work in practice, it throws an exception in the line above as I'm trying to set a string to nil. Oops
				// too bad I have no idea what to do about it
				NSBeginAlertSheet(@"Sorry", nil, nil, nil, [self window], nil, nil, nil, nil,
								  @"I reached the server and tried to download an update, but for some reason could not. Did your connection go out? There could also be a server problem. Try again later.");
				return;
			}
			[currentDownload writeToFile:[NSString stringWithFormat:@"/Users/Shared/Same Game Challenge/Levels/%@", [toBeDownloaded objectAtIndex:lcv]] atomically:YES];
			didNeedUpdates = 1;
		}
	}
	if ( didNeedUpdates == 1 )
		NSBeginAlertSheet(@"Success", nil, nil, nil, [self window], nil, nil, nil, nil,
					  @"All updates have been downloaded. Thanks for playing!");
	else
		NSBeginAlertSheet(@"Nien!", nil, nil, nil, [self window], nil, nil, nil, nil,
						  @"No updates are needed, you are up to date. Thanks for playing!");	
	[self lockFocus];
	[challengeBackground compositeToPoint:NSMakePoint(34, 135) fromRect:NSMakeRect(34, 135, 400, 100) operation:NSCompositeSourceOver];
	[self unlockFocus];
	[[self window] flushWindow];
	[self updateUserListWithDates];
	[self redrawDateSpace];
}	

- (void)updateUserListWithDates
{
	// break out the list file into an array based on "\n". 
	// do this for every player
    	// naturally, the current [playersNamesArray objectAtIndex: lcv] will have a count of at least 3- the name, a score of 0 and the first file
	    // take your count as being [array count] - 3
    	// repeat the number of lines in the list file array - 1, as we are starting at 1
    	  // add this to the string you are building to append onto the players
	      // update the count
	
	int tempSize, lcv2;
	NSArray *listArray = [[NSMutableString stringWithContentsOfFile: @"/Users/Shared/Same Game Challenge/dates"] componentsSeparatedByString:@"\n"];
	NSMutableString *toAdd = [NSMutableString stringWithCapacity :5];
	tempSize = [[[playersNamesArray objectAtIndex: 0] componentsSeparatedByString:@"\n"] count] - 4; // because there's an "\n" on the end, it counts for one
// I can use objectAtIndex:0 here because they are all the same length. If there's 5 on the first, there's 5 on the last, and if I'm adding 3 more, I add it to all of them at once
	for ( lcv2 = tempSize + 1; lcv2 < [listArray count]; lcv2++) {
		[toAdd appendString: [NSString stringWithFormat: @"%@ 0%%\n", [listArray objectAtIndex: lcv2]]];
	}
	[playersNamesArray replaceObjectAtIndex:0 withObject:[NSString stringWithFormat:@"%@%@",[playersNamesArray objectAtIndex: 0], toAdd]];
	[playersNamesArray replaceObjectAtIndex:1 withObject:[NSString stringWithFormat:@"%@%@",[playersNamesArray objectAtIndex: 1], toAdd]];
	[playersNamesArray replaceObjectAtIndex:2 withObject:[NSString stringWithFormat:@"%@%@",[playersNamesArray objectAtIndex: 2], toAdd]];
	[playersNamesArray replaceObjectAtIndex:3 withObject:[NSString stringWithFormat:@"%@%@",[playersNamesArray objectAtIndex: 3], toAdd]];
	[playersNamesArray replaceObjectAtIndex:4 withObject:[NSString stringWithFormat:@"%@%@",[playersNamesArray objectAtIndex: 4], toAdd]];

	[[NSString stringWithFormat:@"%@.\n%@.\n%@.\n%@.\n%@", [playersNamesArray objectAtIndex: 0], [playersNamesArray objectAtIndex: 1],[playersNamesArray objectAtIndex: 2],[playersNamesArray objectAtIndex: 3],[playersNamesArray objectAtIndex: 4]] writeToFile:@"/Users/Shared/Same Game Challenge/UserList" atomically:YES];
	
	
}
- (void)startTheMainGame
{
	int lcv, lcv2;
	
	[self removeTrackingRect:playerBoxTrackingRects[0]];
	[self removeTrackingRect:playerBoxTrackingRects[1]];
	[self removeTrackingRect:playerBoxTrackingRects[2]];
	[self removeTrackingRect:playerBoxTrackingRects[3]];
	[self removeTrackingRect:playerBoxTrackingRects[4]];
	[self removeTrackingRect:normalGameTrackingRect];
	[self removeTrackingRect:challengeGameTrackingRect];
	
	for ( lcv = 0; lcv < 20; lcv++ ){
		for ( lcv2 = 0; lcv2 < 10; lcv2++ ){
			board[lcv][lcv2] = randBetween(1.0,5.0);
		}
	}
// piece 0,1 is to the right 0, and up 1
	[piecesLayer setSize: NSMakeSize(800, 600)];
	[piecesLayer lockFocus];
	for ( lcv = 0; lcv < 20; lcv++ ){
		for ( lcv2 = 0; lcv2 < 10; lcv2++ ){
			if ( board[lcv][lcv2] == goldPiece )
				[gold compositeToPoint:NSMakePoint(lcv * 40, lcv2 * 57) fromRect:NSMakeRect(0, 0, 40, 57) operation:NSCompositeSourceOver];
			if ( board[lcv][lcv2] == treePiece )
				[tree compositeToPoint:NSMakePoint(lcv * 40, lcv2 * 57) fromRect:NSMakeRect(0, 0, 40, 57) operation:NSCompositeSourceOver];
			if ( board[lcv][lcv2] == waterPiece )
				[water compositeToPoint:NSMakePoint(lcv * 40, lcv2 * 57) fromRect:NSMakeRect(0, 0, 40, 57) operation:NSCompositeSourceOver];
			if ( board[lcv][lcv2] == firePiece )
				[fire compositeToPoint:NSMakePoint(lcv * 40, lcv2 * 57) fromRect:NSMakeRect(0, 0, 40, 57) operation:NSCompositeSourceOver];
			boardTrackingRects[lcv][lcv2] = [self addTrackingRect: NSMakeRect((lcv * 40) + 2, (lcv2 * 57) + 2, 36, 53) owner:self userData:[[NSString stringWithFormat :@"%d,%d", lcv,lcv2] retain] assumeInside:NO];
		}
	}
	[piecesLayer unlockFocus];
	[self setNeedsDisplay: YES];
	[gameFont setObject:[NSColor blackColor] forKey:NSForegroundColorAttributeName];
	state = playingMainGame;
	newGameTrakingRect = [self addTrackingRect: NSMakeRect(100, 570, 130, 50) owner:self userData:@"999" assumeInside:NO];
	score = 0;
	squaresLeft = 200;
	[mainBackground release];
	mainBackground = [NSImage imageNamed:[NSString stringWithFormat:@"%d.jpg", (int)randBetween(1,35)]];
	[mainBackground retain];
	// load a random background
	// set up all the tracking rects for the squares
	// put the squares over the background
	// set up the score and new game buttons
	// show the playing field
}

- (void)setTimer:(double)interval
{
    NSTimer	*aTimer;
	
    aTimer = [NSTimer	scheduledTimerWithTimeInterval:interval
												target:self
											  selector:@selector(timerFired:)
											  userInfo:nil
											   repeats:YES];
    if (theTimer) {
		[theTimer invalidate];
		[theTimer release];
		theTimer = nil;
    }
    theTimer = [aTimer retain];
}


//-------------------------------------------------------------
//  stop the timer
//-------------------------------------------------------------
- (void)stopTimer
{
    if (theTimer) {
		[theTimer invalidate];
		[theTimer release];
		theTimer = nil;
    }
}


//-------------------------------------------------------------
//  timer event
//-------------------------------------------------------------
- (void)timerFired:(id)timer
{
    [self setNeedsDisplay:YES];
}

-(void)dealloc
{
	NSLog (@"being dealloced");
	[piecesLayer release];
	[gameFont removeAllObjects];
	[gameFont release];
	[currentChallengeBoards removeAllObjects];
	[currentChallengeBoards release];
	[trackingRects removeAllObjects];
	[playersArray removeAllObjects];
	[playersNamesArray removeAllObjects];
	[challengeList removeAllObjects];
	[challengeList release];
	[challengeBackground release];
	[playersArray release];
	[mainBackground release];
	[loseBackground release];
	[winBackground release];
	[challengeBackground release];
	[acceptPlayerButton release];
	[nameField release];
	[playerName release];
	[specialFont release];
	[fire release];
	[water release];
	[gold release];
	[tree release];
	[tinkSound release];
	[boinkSound release];
	[placeForDate release];
	[yip release];
	[tinkSound release];
	[currentChallengeBoards release];
	[dissolve release];
	[letsgo release];
	[crash release];
	[blork release];
	[bell release];
	[click release];
	[slide release];
	[super dealloc];

}

@end
