#import "MyWindow.h"
#import "MyView.h"

#define BIN 2

@implementation MyWindow

extern void _NSSetWindowOpacity(int windowNumber, BOOL isOpaque);

// little bit of c code here
FLAG set_bit (int Bit, FLAG FlagVar )
{
    return ( FlagVar | (FLAG)pow( BIN,Bit ));
}

FLAG clear_bit( int Bit, FLAG FlagVar )
{
	return ( FlagVar & ~((FLAG)pow( BIN,Bit )));
}

- initWithContentRect:(NSRect)contentRect styleMask:(unsigned int)aStyle backing : (NSBackingStoreType)bufferingType defer:(BOOL)flag
{
    if (self = [super initWithContentRect:contentRect styleMask:NSBorderlessWindowMask backing:bufferingType defer:NO])
        _NSSetWindowOpacity ([self windowNumber], 0);
    
    drawingArea = [[MyView alloc] initWithFrame: NSMakeRect(0, 0, 800, 600) ]; // window sets its own view here
    pos.x = 16;
    pos.y = 16;
    [self setContentView: drawingArea]; // bet you could use subviews to make layers for an SNES 3d effect
    // man, when that first came out, there were like 4 independent layers they could use. Those were the days....
    [self setTimer:.03]; // this makes it go 30 frames a second no matter how powerful your hardware
    return self;
}

- (BOOL)hasShadow
{
    return NO;
}

- (BOOL)acceptsFirstResponder
{
    return YES;
}

- (BOOL)canBecomeKeyWindow
{
    return YES;
}

- (void)keyDown:(NSEvent *)event
{
}


- (void)keyUp:(NSEvent *)event
{
}

- (void)setTimer:(double)interval
{
    NSTimer	*aTimer;

    aTimer = [NSTimer	scheduledTimerWithTimeInterval:interval
			target:self
			selector:@selector(timerFired:)
			userInfo:nil
			repeats:YES];
    if (theTimer) {
	[theTimer invalidate];
	[theTimer release];
	theTimer = nil;
    }
    theTimer = [aTimer retain];
}


//-------------------------------------------------------------
//  stop the timer
//-------------------------------------------------------------
- (void)stopTimer
{
    if (theTimer) {
	[theTimer invalidate];
	[theTimer release];
	theTimer = nil;
    }
}


//-------------------------------------------------------------
//  timer event
//-------------------------------------------------------------
- (void)timerFired:(id)timer
{
}

-(void)dealloc
{
	NSLog (@"more dealloc");
	[theTimer release];	
	[drawingArea release];
	[super dealloc];
}

@end
