#import "mainWindowController.h"
#import "MyWindow.h"

/*
Ok, so I've been wrong all along. At a minimum for a game, you need three things:
1) a window controller. This sets up the window, sets the screen res, etc.
2) an actual window. This handles the events, like keydowns
3) a view. This handles the drawing in the window

I somehow wanted to force the window controller to accept keystrokes, something it will never do, 
because it's not designed for that! Here's a tip: If you want success, let each thing do its job!

So here we have the controller. It sets up the window, which in turn sets up its view. 

The controller does not know about the view, nor should it. 

*/
 
@implementation mainWindowController

- (id)init
{

    [super init];
    window = [[MyWindow alloc]
			initWithContentRect:NSMakeRect( 0.0, 0.0, 800, 600 )	
			styleMask:NSBorderlessWindowMask
			backing:NSBackingStoreBuffered
			defer:NO];
 //   [window setLevel:NSFloatingWindowLevel]; // I would like it to be above the dock, but seeing as apple
    // puts the force quit dialog at a lower level then the dock??? and I don't think anything should
    // obsure the force quit window, I can't do it. Thanks Apple!
    [window center];
    [window makeKeyAndOrderFront:self];
    [window setAlphaValue:1];
    [window setBackgroundColor :[NSColor blackColor]]; // Black for space
    
    return self;
}

@end
